import { RefObject } from "react";
import { MotionValuesMap } from "../motion/utils/use-motion-values";
import { AnimationControls } from "../motion";
declare type DragDirection = "x" | "y";
export declare type Constraints = {
    left?: number;
    right?: number;
    top?: number;
    bottom?: number;
};
export declare type Overdrag = boolean | number;
export interface DraggableProps {
    drag?: boolean | DragDirection | "lockDirection";
    dragPropagation?: boolean;
    dragConstraints?: Constraints;
    dragElastic?: Overdrag;
    dragMomentum?: boolean;
    onDragStart?: (e: MouseEvent | TouchEvent) => void;
    onDragEnd?: (e: MouseEvent | TouchEvent) => void;
    onDirectionLock?: (axis: string) => void;
}
export declare function useDraggable({ drag, dragPropagation, dragConstraints, dragElastic, dragMomentum, onDragStart, onDragEnd, onDirectionLock, }: DraggableProps, ref: RefObject<Element | null>, values: MotionValuesMap, controls: AnimationControls): void;
export {};
