import { EventHandler, TargetOrRef, TargetBasedReturnType } from "./types";
interface MouseEventHandlers {
    onMouseDown: EventHandler;
    onMouseMove: EventHandler;
    onMouseUp: EventHandler;
    onMouseOver: EventHandler;
    onMouseOut: EventHandler;
    onMouseEnter: EventHandler;
    onMouseLeave: EventHandler;
}
export declare const useMouseEvents: <Target extends TargetOrRef>({ onMouseDown, onMouseMove, onMouseUp, onMouseOver, onMouseOut, onMouseEnter, onMouseLeave, }: Partial<MouseEventHandlers>, ref: Target, options?: AddEventListenerOptions | undefined) => TargetBasedReturnType<Target>;
export interface TouchEventHandlers {
    onTouchStart: EventHandler;
    onTouchMove: EventHandler;
    onTouchEnd: EventHandler;
    onTouchCancel: EventHandler;
}
export declare const useTouchEvents: <Target extends TargetOrRef>({ onTouchStart, onTouchMove, onTouchEnd, onTouchCancel, }: Partial<TouchEventHandlers>, ref: Target, options?: AddEventListenerOptions | undefined) => TargetBasedReturnType<Target>;
export declare const useNativePointerEvents: <Target extends TargetOrRef>({ onPointerDown, onPointerMove, onPointerUp, onPointerCancel, onPointerOver, onPointerOut, onPointerEnter, onPointerLeave, }: Partial<PointerEventHandlers>, ref: Target, options?: AddEventListenerOptions | undefined) => TargetBasedReturnType<Target>;
export interface PointerEventHandlers {
    onPointerDown: EventHandler;
    onPointerMove: EventHandler;
    onPointerUp: EventHandler;
    onPointerCancel: EventHandler;
    onPointerOver: EventHandler;
    onPointerOut: EventHandler;
    onPointerEnter: EventHandler;
    onPointerLeave: EventHandler;
}
export declare const usePointerEvents: <Target extends TargetOrRef>(eventHandlers: Partial<PointerEventHandlers>, ref: Target, options?: AddEventListenerOptions | undefined) => TargetBasedReturnType<Target>;
export declare const useConditionalPointerEvents: <Target extends TargetOrRef, Handlers extends Partial<PointerEventHandlers>>(eventHandlers: Handlers, ref?: Target | undefined, options?: AddEventListenerOptions | undefined) => Handlers | undefined;
export {};
