(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
    (factory((global.FramerMotion = {}),global.React));
}(this, (function (exports,React) { 'use strict';

    var htmlTuple = function (args) { return args; };
    var svgTuple = function (args) { return args; };
    var htmlElements = htmlTuple([
        "a",
        "abbr",
        "address",
        "area",
        "article",
        "aside",
        "audio",
        "b",
        "base",
        "bdi",
        "bdo",
        "big",
        "blockquote",
        "body",
        "br",
        "button",
        "canvas",
        "caption",
        "cite",
        "code",
        "col",
        "colgroup",
        "data",
        "datalist",
        "dd",
        "del",
        "details",
        "dfn",
        "dialog",
        "div",
        "dl",
        "dt",
        "em",
        "embed",
        "fieldset",
        "figcaption",
        "figure",
        "footer",
        "form",
        "h1",
        "h2",
        "h3",
        "h4",
        "h5",
        "h6",
        "head",
        "header",
        "hgroup",
        "hr",
        "html",
        "i",
        "iframe",
        "img",
        "input",
        "ins",
        "kbd",
        "keygen",
        "label",
        "legend",
        "li",
        "link",
        "main",
        "map",
        "mark",
        "menu",
        "menuitem",
        "meta",
        "meter",
        "nav",
        "noscript",
        "object",
        "ol",
        "optgroup",
        "option",
        "output",
        "p",
        "param",
        "picture",
        "pre",
        "progress",
        "q",
        "rp",
        "rt",
        "ruby",
        "s",
        "samp",
        "script",
        "section",
        "select",
        "small",
        "source",
        "span",
        "strong",
        "style",
        "sub",
        "summary",
        "sup",
        "table",
        "tbody",
        "td",
        "textarea",
        "tfoot",
        "th",
        "thead",
        "time",
        "title",
        "tr",
        "track",
        "u",
        "ul",
        "var",
        "video",
        "wbr",
        "webview",
    ]);
    var svgElements = svgTuple([
        "animate",
        "circle",
        "clipPath",
        "defs",
        "desc",
        "ellipse",
        "feBlend",
        "feColorMatrix",
        "feComponentTransfer",
        "feComposite",
        "feConvolveMatrix",
        "feDiffuseLighting",
        "feDisplacementMap",
        "feDistantLight",
        "feDropShadow",
        "feFlood",
        "feFuncA",
        "feFuncB",
        "feFuncG",
        "feFuncR",
        "feGaussianBlur",
        "feImage",
        "feMerge",
        "feMergeNode",
        "feMorphology",
        "feOffset",
        "fePointLight",
        "feSpecularLighting",
        "feSpotLight",
        "feTile",
        "feTurbulence",
        "filter",
        "foreignObject",
        "g",
        "image",
        "line",
        "linearGradient",
        "marker",
        "mask",
        "metadata",
        "path",
        "pattern",
        "polygon",
        "polyline",
        "radialGradient",
        "rect",
        "stop",
        "svg",
        "switch",
        "symbol",
        "text",
        "textPath",
        "tspan",
        "use",
        "view",
    ]);
    var elements = htmlElements.concat(svgElements);

    var MotionContext = React.createContext({
        dragging: false,
    });
    var isTarget = function (v) {
        return v !== undefined && typeof v !== "string" && !Array.isArray(v);
    };
    var useMotionContext = function (controls, initial) {
        var parentContext = React.useContext(MotionContext);
        var context = React.useMemo(function () { return ({
            controls: controls,
            initial: initial && !isTarget(initial) ? initial : parentContext.initial,
        }); }, []);
        context.dragging = parentContext.dragging;
        React.useMemo(function () {
            var initialToApply = initial || parentContext.initial;
            initialToApply && controls.apply(initialToApply);
        }, []);
        return context;
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
                t[p[i]] = s[p[i]];
        return t;
    }

    var HEY_LISTEN = 'Hey, listen! ';
    var invariant = function () { };
    {
        invariant = function (check, message) {
            if (!check) {
                throw new Error(HEY_LISTEN.toUpperCase() + message);
            }
        };
    }

    var prevTime = 0;
    var onNextFrame = typeof window !== 'undefined' && window.requestAnimationFrame !== undefined
        ? function (callback) { return window.requestAnimationFrame(callback); }
        : function (callback) {
            var timestamp = Date.now();
            var timeToCall = Math.max(0, 16.7 - (timestamp - prevTime));
            prevTime = timestamp + timeToCall;
            setTimeout(function () { return callback(prevTime); }, timeToCall);
        };

    var createStep = (function (setRunNextFrame) {
        var processToRun = [];
        var processToRunNextFrame = [];
        var numThisFrame = 0;
        var isProcessing = false;
        var i = 0;
        var cancelled = new WeakSet();
        var toKeepAlive = new WeakSet();
        var renderStep = {
            cancel: function (process) {
                var indexOfCallback = processToRunNextFrame.indexOf(process);
                cancelled.add(process);
                if (indexOfCallback !== -1) {
                    processToRunNextFrame.splice(indexOfCallback, 1);
                }
            },
            process: function (frame) {
                var _a;
                isProcessing = true;
                _a = [
                    processToRunNextFrame,
                    processToRun
                ], processToRun = _a[0], processToRunNextFrame = _a[1];
                processToRunNextFrame.length = 0;
                numThisFrame = processToRun.length;
                if (numThisFrame) {
                    var process_1;
                    for (i = 0; i < numThisFrame; i++) {
                        process_1 = processToRun[i];
                        process_1(frame);
                        if (toKeepAlive.has(process_1) === true && !cancelled.has(process_1)) {
                            renderStep.schedule(process_1);
                            setRunNextFrame(true);
                        }
                    }
                }
                isProcessing = false;
            },
            schedule: function (process, keepAlive, immediate) {
                invariant(typeof process === 'function', 'Argument must be a function');
                var addToCurrentBuffer = immediate && isProcessing;
                var buffer = addToCurrentBuffer ? processToRun : processToRunNextFrame;
                if (keepAlive)
                    toKeepAlive.add(process);
                if (buffer.indexOf(process) === -1) {
                    buffer.push(process);
                    if (addToCurrentBuffer)
                        numThisFrame = processToRun.length;
                }
            }
        };
        return renderStep;
    });

    var StepId;
    (function (StepId) {
        StepId["Read"] = "read";
        StepId["Update"] = "update";
        StepId["Render"] = "render";
        StepId["PostRender"] = "postRender";
        StepId["FixedUpdate"] = "fixedUpdate";
    })(StepId || (StepId = {}));

    var maxElapsed = 40;
    var defaultElapsed = (1 / 60) * 1000;
    var useDefaultElapsed = true;
    var willRunNextFrame = false;
    var isProcessing = false;
    var frame = {
        delta: 0,
        timestamp: 0
    };
    var stepsOrder = [
        StepId.Read,
        StepId.Update,
        StepId.Render,
        StepId.PostRender
    ];
    var setWillRunNextFrame = function (willRun) { return (willRunNextFrame = willRun); };
    var _a = stepsOrder.reduce(function (acc, key) {
        var step = createStep(setWillRunNextFrame);
        acc.sync[key] = function (process, keepAlive, immediate) {
            if (keepAlive === void 0) { keepAlive = false; }
            if (immediate === void 0) { immediate = false; }
            if (!willRunNextFrame)
                startLoop();
            step.schedule(process, keepAlive, immediate);
            return process;
        };
        acc.cancelSync[key] = function (process) { return step.cancel(process); };
        acc.steps[key] = step;
        return acc;
    }, {
        steps: {},
        sync: {},
        cancelSync: {}
    }), steps = _a.steps, sync = _a.sync, cancelSync = _a.cancelSync;
    var processStep = function (stepId) { return steps[stepId].process(frame); };
    var processFrame = function (timestamp) {
        willRunNextFrame = false;
        frame.delta = useDefaultElapsed
            ? defaultElapsed
            : Math.max(Math.min(timestamp - frame.timestamp, maxElapsed), 1);
        if (!useDefaultElapsed)
            defaultElapsed = frame.delta;
        frame.timestamp = timestamp;
        isProcessing = true;
        stepsOrder.forEach(processStep);
        isProcessing = false;
        if (willRunNextFrame) {
            useDefaultElapsed = false;
            onNextFrame(processFrame);
        }
    };
    var startLoop = function () {
        willRunNextFrame = true;
        useDefaultElapsed = true;
        if (!isProcessing)
            onNextFrame(processFrame);
    };
    var getFrameData = function () { return frame; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign$1 = function() {
        __assign$1 = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign$1.apply(this, arguments);
    };

    var clamp = function (min, max) { return function (v) {
        return Math.max(Math.min(v, max), min);
    }; };
    var isFirstChars = function (term) { return function (v) {
        return typeof v === 'string' && v.indexOf(term) === 0;
    }; };
    var getValueFromFunctionString = function (value) {
        return value.substring(value.indexOf('(') + 1, value.lastIndexOf(')'));
    };
    var splitCommaDelimited = function (value) {
        return typeof value === 'string' ? value.split(/,\s*/) : [value];
    };
    var sanitize = function (v) { return (v % 1 ? Number(v.toFixed(5)) : v); };

    var number = {
        test: function (v) { return typeof v === 'number'; },
        parse: parseFloat,
        transform: function (v) { return v; }
    };
    var alpha = __assign$1({}, number, { transform: clamp(0, 1) });
    var scale = __assign$1({}, number, { default: 1 });

    var createUnitType = function (unit) { return ({
        test: function (v) {
            return typeof v === 'string' && v.endsWith(unit) && v.split(' ').length === 1;
        },
        parse: parseFloat,
        transform: function (v) { return "" + v + unit; }
    }); };
    var degrees = createUnitType('deg');
    var percent = createUnitType('%');
    var px = createUnitType('px');
    var vh = createUnitType('vh');
    var vw = createUnitType('vw');

    var clampRgbUnit = clamp(0, 255);
    var onlyColorRegex = /^(#[0-9a-f]{3}|#(?:[0-9a-f]{2}){2,4}|(rgb|hsl)a?\((-?\d+%?[,\s]+){2,3}\s*[\d\.]+%?\))$/i;
    var isRgba = function (v) { return v.red !== undefined; };
    var isHsla = function (v) { return v.hue !== undefined; };
    var splitColorValues = function (terms) {
        var numTerms = terms.length;
        return function (v) {
            if (typeof v !== 'string')
                return v;
            var values = {};
            var valuesArray = splitCommaDelimited(getValueFromFunctionString(v));
            for (var i = 0; i < numTerms; i++) {
                values[terms[i]] =
                    valuesArray[i] !== undefined ? parseFloat(valuesArray[i]) : 1;
            }
            return values;
        };
    };
    var rgbaTemplate = function (_a) {
        var red = _a.red, green = _a.green, blue = _a.blue, _b = _a.alpha, alpha$$1 = _b === void 0 ? 1 : _b;
        return "rgba(" + red + ", " + green + ", " + blue + ", " + alpha$$1 + ")";
    };
    var hslaTemplate = function (_a) {
        var hue = _a.hue, saturation = _a.saturation, lightness = _a.lightness, _b = _a.alpha, alpha$$1 = _b === void 0 ? 1 : _b;
        return "hsla(" + hue + ", " + saturation + ", " + lightness + ", " + alpha$$1 + ")";
    };
    var rgbUnit = __assign$1({}, number, { transform: function (v) { return Math.round(clampRgbUnit(v)); } });
    var testRgbaString = isFirstChars('rgb');
    var rgba = {
        test: function (v) { return (typeof v === 'string' ? testRgbaString(v) : isRgba(v)); },
        parse: splitColorValues(['red', 'green', 'blue', 'alpha']),
        transform: function (_a) {
            var red = _a.red, green = _a.green, blue = _a.blue, alpha$$1 = _a.alpha;
            return rgbaTemplate({
                red: rgbUnit.transform(red),
                green: rgbUnit.transform(green),
                blue: rgbUnit.transform(blue),
                alpha: sanitize(alpha$$1)
            });
        }
    };
    var testHslaString = isFirstChars('hsl');
    var hsla = {
        test: function (v) { return (typeof v === 'string' ? testHslaString(v) : isHsla(v)); },
        parse: splitColorValues(['hue', 'saturation', 'lightness', 'alpha']),
        transform: function (_a) {
            var hue = _a.hue, saturation = _a.saturation, lightness = _a.lightness, alpha$$1 = _a.alpha;
            return hslaTemplate({
                hue: Math.round(hue),
                saturation: percent.transform(sanitize(saturation)),
                lightness: percent.transform(sanitize(lightness)),
                alpha: sanitize(alpha$$1)
            });
        }
    };
    var hex = __assign$1({}, rgba, { test: isFirstChars('#'), parse: function (v) {
            var r = '';
            var g = '';
            var b = '';
            if (v.length > 4) {
                r = v.substr(1, 2);
                g = v.substr(3, 2);
                b = v.substr(5, 2);
            }
            else {
                r = v.substr(1, 1);
                g = v.substr(2, 1);
                b = v.substr(3, 1);
                r += r;
                g += g;
                b += b;
            }
            return {
                red: parseInt(r, 16),
                green: parseInt(g, 16),
                blue: parseInt(b, 16),
                alpha: 1
            };
        } });
    var color = {
        test: function (v) {
            return (typeof v === 'string' && onlyColorRegex.test(v)) ||
                rgba.test(v) ||
                hsla.test(v) ||
                hex.test(v);
        },
        parse: function (v) {
            if (rgba.test(v)) {
                return rgba.parse(v);
            }
            else if (hsla.test(v)) {
                return hsla.parse(v);
            }
            else if (hex.test(v)) {
                return hex.parse(v);
            }
            return v;
        },
        transform: function (v) {
            if (isRgba(v)) {
                return rgba.transform(v);
            }
            else if (isHsla(v)) {
                return hsla.transform(v);
            }
            return v;
        }
    };

    var floatRegex = /(-)?(\d[\d\.]*)/g;
    var colorRegex = /(#[0-9a-f]{6}|#[0-9a-f]{3}|#(?:[0-9a-f]{2}){2,4}|(rgb|hsl)a?\((-?\d+%?[,\s]+){2,3}\s*[\d\.]+%?\))/gi;
    var COLOR_TOKEN = '${c}';
    var NUMBER_TOKEN = '${n}';
    var complex = {
        test: function (v) {
            if (typeof v !== 'string' || !isNaN(v))
                return false;
            var numValues = 0;
            var foundNumbers = v.match(floatRegex);
            var foundColors = v.match(colorRegex);
            if (foundNumbers)
                numValues += foundNumbers.length;
            if (foundColors)
                numValues += foundColors.length;
            return numValues > 0;
        },
        parse: function (v) {
            var input = v;
            var parsed = [];
            var foundColors = input.match(colorRegex);
            if (foundColors) {
                input = input.replace(colorRegex, COLOR_TOKEN);
                parsed.push.apply(parsed, foundColors.map(color.parse));
            }
            var foundNumbers = input.match(floatRegex);
            if (foundNumbers) {
                parsed.push.apply(parsed, foundNumbers.map(number.parse));
            }
            return parsed;
        },
        createTransformer: function (prop) {
            var template = prop;
            var token = 0;
            var foundColors = prop.match(colorRegex);
            var numColors = foundColors ? foundColors.length : 0;
            if (foundColors) {
                for (var i = 0; i < numColors; i++) {
                    template = template.replace(foundColors[i], COLOR_TOKEN);
                    token++;
                }
            }
            var foundNumbers = template.match(floatRegex);
            var numNumbers = foundNumbers ? foundNumbers.length : 0;
            if (foundNumbers) {
                for (var i = 0; i < numNumbers; i++) {
                    template = template.replace(foundNumbers[i], NUMBER_TOKEN);
                    token++;
                }
            }
            return function (v) {
                var output = template;
                for (var i = 0; i < token; i++) {
                    output = output.replace(i < numColors ? COLOR_TOKEN : NUMBER_TOKEN, i < numColors ? color.transform(v[i]) : sanitize(v[i]));
                }
                return output;
            };
        }
    };

    var DEFAULT_OVERSHOOT_STRENGTH = 1.525;
    var reversed = function (easing) {
        return function (p) {
            return 1 - easing(1 - p);
        };
    };
    var mirrored = function (easing) {
        return function (p) {
            return p <= 0.5 ? easing(2 * p) / 2 : (2 - easing(2 * (1 - p))) / 2;
        };
    };
    var createExpoIn = function (power) {
        return function (p) {
            return Math.pow(p, power);
        };
    };
    var createBackIn = function (power) {
        return function (p) {
            return p * p * ((power + 1) * p - power);
        };
    };
    var createAnticipateEasing = function (power) {
        var backEasing = createBackIn(power);
        return function (p) {
            return (p *= 2) < 1 ? 0.5 * backEasing(p) : 0.5 * (2 - Math.pow(2, -10 * (p - 1)));
        };
    };
    var linear = function (p) {
        return p;
    };
    var easeIn = /*#__PURE__*/createExpoIn(2);
    var easeOut = /*#__PURE__*/reversed(easeIn);
    var easeInOut = /*#__PURE__*/mirrored(easeIn);
    var circIn = function (p) {
        return 1 - Math.sin(Math.acos(p));
    };
    var circOut = /*#__PURE__*/reversed(circIn);
    var circInOut = /*#__PURE__*/mirrored(circOut);
    var backIn = /*#__PURE__*/createBackIn(DEFAULT_OVERSHOOT_STRENGTH);
    var backOut = /*#__PURE__*/reversed(backIn);
    var backInOut = /*#__PURE__*/mirrored(backIn);
    var anticipate = /*#__PURE__*/createAnticipateEasing(DEFAULT_OVERSHOOT_STRENGTH);
    var NEWTON_ITERATIONS = 8;
    var NEWTON_MIN_SLOPE = 0.001;
    var SUBDIVISION_PRECISION = 0.0000001;
    var SUBDIVISION_MAX_ITERATIONS = 10;
    var K_SPLINE_TABLE_SIZE = 11;
    var K_SAMPLE_STEP_SIZE = 1.0 / (K_SPLINE_TABLE_SIZE - 1.0);
    var FLOAT_32_SUPPORTED = typeof Float32Array !== 'undefined';
    var a = function (a1, a2) {
        return 1.0 - 3.0 * a2 + 3.0 * a1;
    };
    var b = function (a1, a2) {
        return 3.0 * a2 - 6.0 * a1;
    };
    var c = function (a1) {
        return 3.0 * a1;
    };
    var getSlope = function (t, a1, a2) {
        return 3.0 * a(a1, a2) * t * t + 2.0 * b(a1, a2) * t + c(a1);
    };
    var calcBezier = function (t, a1, a2) {
        return ((a(a1, a2) * t + b(a1, a2)) * t + c(a1)) * t;
    };
    function cubicBezier(mX1, mY1, mX2, mY2) {
        var sampleValues = FLOAT_32_SUPPORTED ? new Float32Array(K_SPLINE_TABLE_SIZE) : new Array(K_SPLINE_TABLE_SIZE);
        var binarySubdivide = function (aX, aA, aB) {
            var i = 0;
            var currentX;
            var currentT;
            do {
                currentT = aA + (aB - aA) / 2.0;
                currentX = calcBezier(currentT, mX1, mX2) - aX;
                if (currentX > 0.0) {
                    aB = currentT;
                } else {
                    aA = currentT;
                }
            } while (Math.abs(currentX) > SUBDIVISION_PRECISION && ++i < SUBDIVISION_MAX_ITERATIONS);
            return currentT;
        };
        var newtonRaphsonIterate = function (aX, aGuessT) {
            var i = 0;
            var currentSlope = 0;
            var currentX;
            for (; i < NEWTON_ITERATIONS; ++i) {
                currentSlope = getSlope(aGuessT, mX1, mX2);
                if (currentSlope === 0.0) {
                    return aGuessT;
                }
                currentX = calcBezier(aGuessT, mX1, mX2) - aX;
                aGuessT -= currentX / currentSlope;
            }
            return aGuessT;
        };
        var calcSampleValues = function () {
            for (var i = 0; i < K_SPLINE_TABLE_SIZE; ++i) {
                sampleValues[i] = calcBezier(i * K_SAMPLE_STEP_SIZE, mX1, mX2);
            }
        };
        var getTForX = function (aX) {
            var intervalStart = 0.0;
            var currentSample = 1;
            var lastSample = K_SPLINE_TABLE_SIZE - 1;
            var dist = 0.0;
            var guessForT = 0.0;
            var initialSlope = 0.0;
            for (; currentSample !== lastSample && sampleValues[currentSample] <= aX; ++currentSample) {
                intervalStart += K_SAMPLE_STEP_SIZE;
            }
            --currentSample;
            dist = (aX - sampleValues[currentSample]) / (sampleValues[currentSample + 1] - sampleValues[currentSample]);
            guessForT = intervalStart + dist * K_SAMPLE_STEP_SIZE;
            initialSlope = getSlope(guessForT, mX1, mX2);
            if (initialSlope >= NEWTON_MIN_SLOPE) {
                return newtonRaphsonIterate(aX, guessForT);
            } else if (initialSlope === 0.0) {
                return guessForT;
            } else {
                return binarySubdivide(aX, intervalStart, intervalStart + K_SAMPLE_STEP_SIZE);
            }
        };
        calcSampleValues();
        var resolver = function (aX) {
            var returnValue;
            if (mX1 === mY1 && mX2 === mY2) {
                returnValue = aX;
            } else if (aX === 0) {
                returnValue = 0;
            } else if (aX === 1) {
                returnValue = 1;
            } else {
                returnValue = calcBezier(getTForX(aX), mY1, mY2);
            }
            return returnValue;
        };
        return resolver;
    }

    var zeroPoint = {
        x: 0,
        y: 0,
        z: 0
    };
    var isNum = function (v) { return typeof v === 'number'; };

    var radiansToDegrees = (function (radians) { return (radians * 180) / Math.PI; });

    var angle = (function (a, b) {
        if (b === void 0) { b = zeroPoint; }
        return radiansToDegrees(Math.atan2(b.y - a.y, b.x - a.x));
    });

    var applyOffset = (function (from, to) {
        var hasReceivedFrom = true;
        if (to === undefined) {
            to = from;
            hasReceivedFrom = false;
        }
        return function (v) {
            if (hasReceivedFrom) {
                return v - from + to;
            }
            else {
                from = v;
                hasReceivedFrom = true;
                return to;
            }
        };
    });

    var curryRange = (function (func) { return function (min, max, v) { return (v !== undefined ? func(min, max, v) : function (cv) { return func(min, max, cv); }); }; });

    var clamp$1 = function (min, max, v) {
        return Math.min(Math.max(v, min), max);
    };
    var clamp$1$1 = curryRange(clamp$1);

    var conditional = (function (check, apply) { return function (v) {
        return check(v) ? apply(v) : v;
    }; });

    var degreesToRadians = (function (degrees$$1) { return (degrees$$1 * Math.PI) / 180; });

    var isPoint = (function (point) {
        return point.hasOwnProperty('x') && point.hasOwnProperty('y');
    });

    var isPoint3D = (function (point) {
        return isPoint(point) && point.hasOwnProperty('z');
    });

    var distance1D = function (a, b) { return Math.abs(a - b); };
    var distance = (function (a, b) {
        if (b === void 0) { b = zeroPoint; }
        if (isNum(a) && isNum(b)) {
            return distance1D(a, b);
        }
        else if (isPoint(a) && isPoint(b)) {
            var xDelta = distance1D(a.x, b.x);
            var yDelta = distance1D(a.y, b.y);
            var zDelta = isPoint3D(a) && isPoint3D(b) ? distance1D(a.z, b.z) : 0;
            return Math.sqrt(Math.pow(xDelta, 2) + Math.pow(yDelta, 2) + Math.pow(zDelta, 2));
        }
        return 0;
    });

    var progress = (function (from, to, value) {
        var toFromDifference = to - from;
        return toFromDifference === 0 ? 1 : (value - from) / toFromDifference;
    });

    var mix = (function (from, to, progress) {
        return -progress * from + progress * to + from;
    });

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign$2 = function() {
        __assign$2 = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign$2.apply(this, arguments);
    };

    var mixLinearColor = function (from, to, v) {
        var fromExpo = from * from;
        var toExpo = to * to;
        return Math.sqrt(v * (toExpo - fromExpo) + fromExpo);
    };
    var colorTypes = [hex, rgba, hsla];
    var getColorType = function (v) {
        return colorTypes.find(function (type) { return type.test(v); });
    };
    var mixColor = (function (from, to) {
        var fromColorType = getColorType(from);
        var toColorType = getColorType(to);
        invariant(fromColorType.transform === toColorType.transform, 'Both colors must be Hex and/or RGBA, or both must be HSLA');
        var fromColor = fromColorType.parse(from);
        var toColor = toColorType.parse(to);
        var blended = __assign$2({}, fromColor);
        var mixFunc = fromColorType === hsla ? mix : mixLinearColor;
        return function (v) {
            for (var key in blended) {
                if (key !== 'alpha') {
                    blended[key] = mixFunc(fromColor[key], toColor[key], v);
                }
            }
            blended.alpha = mix(fromColor.alpha, toColor.alpha, v);
            return fromColorType.transform(blended);
        };
    });

    var combineFunctions = function (a, b) { return function (v) { return b(a(v)); }; };
    var pipe = (function () {
        var transformers = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            transformers[_i] = arguments[_i];
        }
        return transformers.reduce(combineFunctions);
    });

    var mixArray = function (from, to) {
        var output = from.slice();
        var numValues = output.length;
        var blendValue = from.map(function (fromThis, i) {
            var toThis = to[i];
            if (isNum(fromThis)) {
                return function (v) { return mix(fromThis, toThis, v); };
            }
            else if (color.test(fromThis)) {
                return mixColor(fromThis, toThis);
            }
            else {
                return mixComplex(fromThis, toThis);
            }
        });
        return function (v) {
            for (var i = 0; i < numValues; i++) {
                output[i] = blendValue[i](v);
            }
            return output;
        };
    };
    var mixComplex = function (from, to) {
        var valueTemplate = complex.createTransformer(from);
        invariant(valueTemplate(from) === complex.createTransformer(to)(from), "Values '" + from + "' and '" + to + "' are of different format, or a value might have changed value type.");
        return pipe(mixArray(complex.parse(from), complex.parse(to)), valueTemplate);
    };

    var mixNumber = curryRange(mix);
    var getMixer = function (v) {
        return typeof v === 'number'
            ? mixNumber
            : color.test(v)
                ? mixColor
                : mixComplex;
    };
    var createMixers = function (output, ease) {
        return Array(output.length - 1)
            .fill(getMixer(output[0]))
            .map(function (factory, i) {
            var mixer = factory(output[i], output[i + 1]);
            if (ease) {
                var easingFunction = Array.isArray(ease) ? ease[i] : ease;
                return pipe(easingFunction, mixer);
            }
            else {
                return mixer;
            }
        });
    };
    var fastInterpolate = function (_a, _b) {
        var from = _a[0], to = _a[1];
        var mixer = _b[0];
        return function (v) { return mixer(progress(from, to, v)); };
    };
    var slowInterpolate = function (input, mixers) {
        var inputLength = input.length;
        var lastInputIndex = inputLength - 1;
        return function (v) {
            var mixerIndex = 0;
            var foundMixerIndex = false;
            if (v <= input[0]) {
                foundMixerIndex = true;
            }
            else if (v >= input[lastInputIndex]) {
                mixerIndex = lastInputIndex - 1;
                foundMixerIndex = true;
            }
            if (!foundMixerIndex) {
                var i = 1;
                for (; i < inputLength; i++) {
                    if (input[i] > v || i === lastInputIndex) {
                        break;
                    }
                }
                mixerIndex = i - 1;
            }
            var progressInRange = progress(input[mixerIndex], input[mixerIndex + 1], v);
            return mixers[mixerIndex](progressInRange);
        };
    };
    var interpolate = (function (input, output, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.clamp, clamp = _c === void 0 ? true : _c, ease = _b.ease;
        var inputLength = input.length;
        invariant(inputLength === output.length, 'Both input and output ranges must be the same length');
        invariant(!ease || !Array.isArray(ease) || ease.length === input.length - 1, 'Array of easing functions must be of length `input.length - 1`, as it applies to the transitions **between** the defined values.');
        if (input[0] > input[inputLength - 1]) {
            input = input.slice();
            output = output.slice();
            input.reverse();
            output.reverse();
        }
        var mixers = createMixers(output, ease);
        var interpolate = inputLength === 2
            ? fastInterpolate(input, mixers)
            : slowInterpolate(input, mixers);
        return clamp
            ? pipe(clamp$1$1(input[0], input[inputLength - 1]), interpolate)
            : interpolate;
    });

    var pointFromVector = (function (origin, angle, distance) {
        angle = degreesToRadians(angle);
        return {
            x: distance * Math.cos(angle) + origin.x,
            y: distance * Math.sin(angle) + origin.y
        };
    });

    var toDecimal = (function (num, precision) {
        if (precision === void 0) { precision = 2; }
        precision = Math.pow(10, precision);
        return Math.round(num * precision) / precision;
    });

    var smoothFrame = (function (prevValue, nextValue, duration, smoothing) {
        if (smoothing === void 0) { smoothing = 0; }
        return toDecimal(prevValue +
            (duration * (nextValue - prevValue)) / Math.max(smoothing, duration));
    });

    var smooth = (function (strength) {
        if (strength === void 0) { strength = 50; }
        var previousValue = 0;
        var lastUpdated = 0;
        return function (v) {
            var currentFramestamp = getFrameData().timestamp;
            var timeDelta = currentFramestamp !== lastUpdated ? currentFramestamp - lastUpdated : 0;
            var newValue = timeDelta
                ? smoothFrame(previousValue, v, timeDelta, strength)
                : previousValue;
            lastUpdated = currentFramestamp;
            previousValue = newValue;
            return newValue;
        };
    });

    var snap = (function (points) {
        if (typeof points === 'number') {
            return function (v) { return Math.round(v / points) * points; };
        }
        else {
            var i_1 = 0;
            var numPoints_1 = points.length;
            return function (v) {
                var lastDistance = Math.abs(points[0] - v);
                for (i_1 = 1; i_1 < numPoints_1; i_1++) {
                    var point = points[i_1];
                    var distance = Math.abs(point - v);
                    if (distance === 0)
                        return point;
                    if (distance > lastDistance)
                        return points[i_1 - 1];
                    if (i_1 === numPoints_1 - 1)
                        return point;
                    lastDistance = distance;
                }
            };
        }
    });

    var identity = function (v) { return v; };
    var springForce = function (alterDisplacement) {
        if (alterDisplacement === void 0) { alterDisplacement = identity; }
        return curryRange(function (constant, origin, v) {
            var displacement = origin - v;
            var springModifiedDisplacement = -(0 - constant + 1) * (0 - alterDisplacement(Math.abs(displacement)));
            return displacement <= 0
                ? origin + springModifiedDisplacement
                : origin - springModifiedDisplacement;
        });
    };
    var springForceLinear = springForce();
    var springForceExpo = springForce(Math.sqrt);

    var velocityPerFrame = (function (xps, frameDuration) {
        return isNum(xps) ? xps / (1000 / frameDuration) : 0;
    });

    var velocityPerSecond = (function (velocity, frameDuration) {
        return frameDuration ? velocity * (1000 / frameDuration) : 0;
    });

    var wrap = function (min, max, v) {
        var rangeSize = max - min;
        return ((((v - min) % rangeSize) + rangeSize) % rangeSize) + min;
    };
    var wrap$1 = curryRange(wrap);

    var clampProgress = clamp$1$1(0, 1);

    var createStyler = function (_a) {
        var onRead = _a.onRead,
            onRender = _a.onRender,
            _b = _a.uncachedValues,
            uncachedValues = _b === void 0 ? new Set() : _b,
            _c = _a.useCache,
            useCache = _c === void 0 ? true : _c;
        return function (props) {
            var state = {};
            var changedValues = [];
            var hasChanged = false;
            var setValue = function (key, value) {
                var currentValue = state[key];
                state[key] = value;
                if (state[key] !== currentValue) {
                    if (changedValues.indexOf(key) === -1) {
                        changedValues.push(key);
                    }
                    if (!hasChanged) {
                        hasChanged = true;
                        sync.render(render);
                    }
                }
            };
            function render(forceRender) {
                if (forceRender === void 0) {
                    forceRender = false;
                }
                if (forceRender === true || hasChanged) {
                    onRender(state, props, changedValues);
                    hasChanged = false;
                    changedValues.length = 0;
                }
                return this;
            }
            return {
                get: function (key) {
                    return key ? useCache && !uncachedValues.has(key) && state[key] !== undefined ? state[key] : onRead(key, props) : state;
                },
                set: function (values, value) {
                    if (typeof values === 'string') {
                        if (value !== undefined) {
                            setValue(values, value);
                        } else {
                            return function (v) {
                                return setValue(values, v);
                            };
                        }
                    } else {
                        for (var key in values) {
                            if (values.hasOwnProperty(key)) {
                                setValue(key, values[key]);
                            }
                        }
                    }
                    return this;
                },
                render: render
            };
        };
    };

    var CAMEL_CASE_PATTERN = /([a-z])([A-Z])/g;
    var REPLACE_TEMPLATE = '$1-$2';
    var camelToDash = function (str) {
        return str.replace(CAMEL_CASE_PATTERN, REPLACE_TEMPLATE).toLowerCase();
    };
    var setDomAttrs = function (element, attrs) {
        for (var key in attrs) {
            if (attrs.hasOwnProperty(key)) {
                element.setAttribute(key, attrs[key]);
            }
        }
    };

    var camelCache = /*#__PURE__*/new Map();
    var dashCache = /*#__PURE__*/new Map();
    var prefixes = ['Webkit', 'Moz', 'O', 'ms', ''];
    var numPrefixes = prefixes.length;
    var isBrowser = typeof document !== 'undefined';
    var testElement;
    var setDashPrefix = function (key, prefixed) {
        return dashCache.set(key, camelToDash(prefixed));
    };
    var testPrefix = function (key) {
        testElement = testElement || document.createElement('div');
        for (var i = 0; i < numPrefixes; i++) {
            var prefix = prefixes[i];
            var noPrefix = prefix === '';
            var prefixedPropertyName = noPrefix ? key : prefix + key.charAt(0).toUpperCase() + key.slice(1);
            if (prefixedPropertyName in testElement.style || noPrefix) {
                camelCache.set(key, prefixedPropertyName);
                setDashPrefix(key, "" + (noPrefix ? '' : '-') + camelToDash(prefixedPropertyName));
            }
        }
    };
    var setServerProperty = function (key) {
        return setDashPrefix(key, key);
    };
    var prefixer = function (key, asDashCase) {
        if (asDashCase === void 0) {
            asDashCase = false;
        }
        var cache = asDashCase ? dashCache : camelCache;
        if (!cache.has(key)) isBrowser ? testPrefix(key) : setServerProperty(key);
        return cache.get(key) || key;
    };

    var axes = ['', 'X', 'Y', 'Z'];
    var order = ['scale', 'rotate', 'skew', 'transformPerspective'];
    var transformProps = /*#__PURE__*/order.reduce(function (acc, key) {
        return axes.reduce(function (axesAcc, axesKey) {
            axesAcc.push(key + axesKey);
            return axesAcc;
        }, acc);
    }, ['x', 'y', 'z']);
    var transformPropDictionary = /*#__PURE__*/transformProps.reduce(function (dict, key) {
        dict[key] = true;
        return dict;
    }, {});
    var isTransformProp = function (key) {
        return transformPropDictionary[key] === true;
    };

    var valueTypes = {
        color: color,
        backgroundColor: color,
        outlineColor: color,
        fill: color,
        stroke: color,
        borderColor: color,
        borderTopColor: color,
        borderRightColor: color,
        borderBottomColor: color,
        borderLeftColor: color,
        borderWidth: px,
        borderTopWidth: px,
        borderRightWidth: px,
        borderBottomWidth: px,
        borderLeftWidth: px,
        borderRadius: px,
        borderTopLeftRadius: px,
        borderTopRightRadius: px,
        borderBottomRightRadius: px,
        borderBottomLeftRadius: px,
        width: px,
        maxWidth: px,
        height: px,
        maxHeight: px,
        top: px,
        right: px,
        bottom: px,
        left: px,
        padding: px,
        paddingTop: px,
        paddingRight: px,
        paddingBottom: px,
        paddingLeft: px,
        margin: px,
        marginTop: px,
        marginRight: px,
        marginBottom: px,
        marginLeft: px,
        rotate: degrees,
        rotateX: degrees,
        rotateY: degrees,
        rotateZ: degrees,
        scale: scale,
        scaleX: scale,
        scaleY: scale,
        scaleZ: scale,
        skew: degrees,
        skewX: degrees,
        skewY: degrees,
        distance: px,
        x: px,
        y: px,
        z: px,
        perspective: px,
        opacity: alpha,
        originX: percent,
        originY: percent,
        originZ: px
    };
    var getValueType = function (key) {
        return valueTypes[key];
    };

    var SCROLL_LEFT = 'scrollLeft';
    var SCROLL_TOP = 'scrollTop';
    var scrollKeys = /*#__PURE__*/new Set([SCROLL_LEFT, SCROLL_TOP]);

    var cssStyler = /*#__PURE__*/createStyler({
        onRead: function (key, _a) {
            var element = _a.element,
                preparseOutput = _a.preparseOutput;
            var valueType = getValueType(key);
            if (isTransformProp(key)) {
                return valueType ? valueType.default || 0 : 0;
            } else if (scrollKeys.has(key)) {
                return element[key];
            } else {
                var domValue = window.getComputedStyle(element, null).getPropertyValue(prefixer(key, true)) || 0;
                return preparseOutput && valueType && valueType.parse ? valueType.parse(domValue) : domValue;
            }
        },
        onRender: function (state, _a, changedValues) {
            var element = _a.element,
                buildStyles = _a.buildStyles;
            Object.assign(element.style, buildStyles(state));
            if (changedValues.indexOf(SCROLL_LEFT) !== -1) element.scrollLeft = state.scrollLeft;
            if (changedValues.indexOf(SCROLL_TOP) !== -1) element.scrollTop = state.scrollTop;
        },
        uncachedValues: scrollKeys
    });

    var ZERO_NOT_ZERO = 0.0000001;
    var percentToPixels = function (percent$$1, length) {
        return percent$$1 / 100 * length + 'px';
    };
    var build = function (state, dimensions, isPath, pathLength) {
        var hasTransform = false;
        var hasDashArray = false;
        var props = {};
        var dashArrayStyles = isPath ? {
            pathLength: '0',
            pathSpacing: "" + pathLength
        } : undefined;
        var scale$$1 = state.scale !== undefined ? state.scale || ZERO_NOT_ZERO : state.scaleX || 1;
        var scaleY = state.scaleY !== undefined ? state.scaleY || ZERO_NOT_ZERO : scale$$1 || 1;
        var transformOriginX = dimensions.width * ((state.originX || 50) / 100) + dimensions.x;
        var transformOriginY = dimensions.height * ((state.originY || 50) / 100) + dimensions.y;
        var scaleTransformX = -transformOriginX * (scale$$1 * 1);
        var scaleTransformY = -transformOriginY * (scaleY * 1);
        var scaleReplaceX = transformOriginX / scale$$1;
        var scaleReplaceY = transformOriginY / scaleY;
        var transform = {
            translate: "translate(" + state.x + ", " + state.y + ") ",
            scale: "translate(" + scaleTransformX + ", " + scaleTransformY + ") scale(" + scale$$1 + ", " + scaleY + ") translate(" + scaleReplaceX + ", " + scaleReplaceY + ") ",
            rotate: "rotate(" + state.rotate + ", " + transformOriginX + ", " + transformOriginY + ") ",
            skewX: "skewX(" + state.skewX + ") ",
            skewY: "skewY(" + state.skewY + ") "
        };
        for (var key in state) {
            if (state.hasOwnProperty(key)) {
                var value = state[key];
                if (isTransformProp(key)) {
                    hasTransform = true;
                } else if (isPath && (key === 'pathLength' || key === 'pathSpacing') && typeof value === 'number') {
                    hasDashArray = true;
                    dashArrayStyles[key] = percentToPixels(value, pathLength);
                } else if (isPath && key === 'pathOffset') {
                    props['stroke-dashoffset'] = percentToPixels(-value, pathLength);
                } else {
                    props[camelToDash(key)] = value;
                }
            }
        }
        if (hasDashArray) {
            props['stroke-dasharray'] = dashArrayStyles.pathLength + ' ' + dashArrayStyles.pathSpacing;
        }
        if (hasTransform) {
            props.transform = '';
            for (var key in transform) {
                if (transform.hasOwnProperty(key)) {
                    var defaultValue = key === 'scale' ? '1' : '0';
                    props.transform += transform[key].replace(/undefined/g, defaultValue);
                }
            }
        }
        return props;
    };

    var valueTypes$1 = {
        fill: color,
        stroke: color,
        scale: scale,
        scaleX: scale,
        scaleY: scale,
        opacity: alpha,
        fillOpacity: alpha,
        strokeOpacity: alpha
    };
    var getValueType$1 = function (key) {
        return valueTypes$1[key];
    };

    var svgStyler = /*#__PURE__*/createStyler({
        onRead: function (key, _a) {
            var element = _a.element;
            if (!isTransformProp(key)) {
                return element.getAttribute(key);
            } else {
                var valueType = getValueType$1(key);
                return valueType ? valueType.default : 0;
            }
        },
        onRender: function (state, _a) {
            var dimensions = _a.dimensions,
                element = _a.element,
                isPath = _a.isPath,
                pathLength = _a.pathLength;
            setDomAttrs(element, build(state, dimensions, isPath, pathLength));
        }
    });

    var viewport = /*#__PURE__*/createStyler({
        useCache: false,
        onRead: function (key) {
            return key === 'scrollTop' ? window.pageYOffset : window.pageXOffset;
        },
        onRender: function (_a) {
            var _b = _a.scrollTop,
                scrollTop = _b === void 0 ? 0 : _b,
                _c = _a.scrollLeft,
                scrollLeft = _c === void 0 ? 0 : _c;
            return window.scrollTo(scrollLeft, scrollTop);
        }
    });

    var Chainable = /*#__PURE__*/function () {
        function Chainable(props) {
            if (props === void 0) {
                props = {};
            }
            this.props = props;
        }
        Chainable.prototype.applyMiddleware = function (middleware) {
            return this.create(__assign({}, this.props, { middleware: this.props.middleware ? [middleware].concat(this.props.middleware) : [middleware] }));
        };
        Chainable.prototype.pipe = function () {
            var funcs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                funcs[_i] = arguments[_i];
            }
            var pipedUpdate = funcs.length === 1 ? funcs[0] : pipe.apply(void 0, funcs);
            return this.applyMiddleware(function (update) {
                return function (v) {
                    return update(pipedUpdate(v));
                };
            });
        };
        Chainable.prototype.while = function (predicate) {
            return this.applyMiddleware(function (update, complete) {
                return function (v) {
                    return predicate(v) ? update(v) : complete();
                };
            });
        };
        Chainable.prototype.filter = function (predicate) {
            return this.applyMiddleware(function (update) {
                return function (v) {
                    return predicate(v) && update(v);
                };
            });
        };
        return Chainable;
    }();

    var Observer = /*#__PURE__*/function () {
        function Observer(_a, observer) {
            var middleware = _a.middleware,
                onComplete = _a.onComplete;
            var _this = this;
            this.isActive = true;
            this.update = function (v) {
                if (_this.observer.update) _this.updateObserver(v);
            };
            this.complete = function () {
                if (_this.observer.complete && _this.isActive) _this.observer.complete();
                if (_this.onComplete) _this.onComplete();
                _this.isActive = false;
            };
            this.error = function (err) {
                if (_this.observer.error && _this.isActive) _this.observer.error(err);
                _this.isActive = false;
            };
            this.observer = observer;
            this.updateObserver = function (v) {
                return observer.update(v);
            };
            this.onComplete = onComplete;
            if (observer.update && middleware && middleware.length) {
                middleware.forEach(function (m) {
                    return _this.updateObserver = m(_this.updateObserver, _this.complete);
                });
            }
        }
        return Observer;
    }();
    var createObserver = function (observerCandidate, _a, onComplete) {
        var middleware = _a.middleware;
        if (typeof observerCandidate === 'function') {
            return new Observer({ middleware: middleware, onComplete: onComplete }, { update: observerCandidate });
        } else {
            return new Observer({ middleware: middleware, onComplete: onComplete }, observerCandidate);
        }
    };

    var Action = /*#__PURE__*/function (_super) {
        __extends(Action, _super);
        function Action() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Action.prototype.create = function (props) {
            return new Action(props);
        };
        Action.prototype.start = function (observerCandidate) {
            if (observerCandidate === void 0) {
                observerCandidate = {};
            }
            var isComplete = false;
            var subscription = {
                stop: function () {
                    return undefined;
                }
            };
            var _a = this.props,
                init = _a.init,
                observerProps = __rest(_a, ["init"]);
            var observer = createObserver(observerCandidate, observerProps, function () {
                isComplete = true;
                subscription.stop();
            });
            var api = init(observer);
            subscription = api ? __assign({}, subscription, api) : subscription;
            if (observerCandidate.registerParent) {
                observerCandidate.registerParent(subscription);
            }
            if (isComplete) subscription.stop();
            return subscription;
        };
        return Action;
    }(Chainable);
    var action = function (init) {
        return new Action({ init: init });
    };

    var BaseMulticast = /*#__PURE__*/function (_super) {
        __extends(BaseMulticast, _super);
        function BaseMulticast() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.subscribers = [];
            return _this;
        }
        BaseMulticast.prototype.complete = function () {
            this.subscribers.forEach(function (subscriber) {
                return subscriber.complete();
            });
        };
        BaseMulticast.prototype.error = function (err) {
            this.subscribers.forEach(function (subscriber) {
                return subscriber.error(err);
            });
        };
        BaseMulticast.prototype.update = function (v) {
            for (var i = 0; i < this.subscribers.length; i++) {
                this.subscribers[i].update(v);
            }
        };
        BaseMulticast.prototype.subscribe = function (observerCandidate) {
            var _this = this;
            var observer = createObserver(observerCandidate, this.props);
            this.subscribers.push(observer);
            var subscription = {
                unsubscribe: function () {
                    var index$$1 = _this.subscribers.indexOf(observer);
                    if (index$$1 !== -1) _this.subscribers.splice(index$$1, 1);
                }
            };
            return subscription;
        };
        BaseMulticast.prototype.stop = function () {
            if (this.parent) this.parent.stop();
        };
        BaseMulticast.prototype.registerParent = function (subscription) {
            this.stop();
            this.parent = subscription;
        };
        return BaseMulticast;
    }(Chainable);

    var Multicast = /*#__PURE__*/function (_super) {
        __extends(Multicast, _super);
        function Multicast() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Multicast.prototype.create = function (props) {
            return new Multicast(props);
        };
        return Multicast;
    }(BaseMulticast);

    var stepProgress = function (steps, progress$$1) {
        var segment = 1 / (steps - 1);
        var subsegment = 1 / (2 * (steps - 1));
        var percentProgressOfTarget = Math.min(progress$$1, 1);
        var subsegmentProgressOfTarget = percentProgressOfTarget / subsegment;
        var segmentProgressOfTarget = Math.floor((subsegmentProgressOfTarget + 1) / 2);
        return segmentProgressOfTarget * segment;
    };

    var calc = /*#__PURE__*/Object.freeze({
        angle: angle,
        degreesToRadians: degreesToRadians,
        distance: distance,
        isPoint3D: isPoint3D,
        isPoint: isPoint,
        dilate: mix,
        getValueFromProgress: mix,
        pointFromAngleAndDistance: pointFromVector,
        getProgressFromValue: progress,
        radiansToDegrees: radiansToDegrees,
        smooth: smoothFrame,
        speedPerFrame: velocityPerFrame,
        speedPerSecond: velocityPerSecond,
        stepProgress: stepProgress
    });

    var isValueList = function (v) {
        return Array.isArray(v);
    };
    var isSingleValue = function (v) {
        var typeOfV = typeof v;
        return typeOfV === 'string' || typeOfV === 'number';
    };
    var ValueReaction = /*#__PURE__*/function (_super) {
        __extends(ValueReaction, _super);
        function ValueReaction(props) {
            var _this = _super.call(this, props) || this;
            _this.scheduleVelocityCheck = function () {
                return sync.postRender(_this.velocityCheck);
            };
            _this.velocityCheck = function (_a) {
                var timestamp = _a.timestamp;
                if (timestamp !== _this.lastUpdated) {
                    _this.prev = _this.current;
                }
            };
            _this.prev = _this.current = props.value || 0;
            if (isSingleValue(_this.current)) {
                _this.updateCurrent = function (v) {
                    return _this.current = v;
                };
                _this.getVelocityOfCurrent = function () {
                    return _this.getSingleVelocity(_this.current, _this.prev);
                };
            } else if (isValueList(_this.current)) {
                _this.updateCurrent = function (v) {
                    return _this.current = v.slice();
                };
                _this.getVelocityOfCurrent = function () {
                    return _this.getListVelocity();
                };
            } else {
                _this.updateCurrent = function (v) {
                    _this.current = {};
                    for (var key in v) {
                        if (v.hasOwnProperty(key)) {
                            _this.current[key] = v[key];
                        }
                    }
                };
                _this.getVelocityOfCurrent = function () {
                    return _this.getMapVelocity();
                };
            }
            if (props.initialSubscription) _this.subscribe(props.initialSubscription);
            return _this;
        }
        ValueReaction.prototype.create = function (props) {
            return new ValueReaction(props);
        };
        ValueReaction.prototype.get = function () {
            return this.current;
        };
        ValueReaction.prototype.getVelocity = function () {
            return this.getVelocityOfCurrent();
        };
        ValueReaction.prototype.update = function (v) {
            _super.prototype.update.call(this, v);
            this.prev = this.current;
            this.updateCurrent(v);
            var _a = getFrameData(),
                delta = _a.delta,
                timestamp = _a.timestamp;
            this.timeDelta = delta;
            this.lastUpdated = timestamp;
            sync.postRender(this.scheduleVelocityCheck);
        };
        ValueReaction.prototype.subscribe = function (observerCandidate) {
            var sub = _super.prototype.subscribe.call(this, observerCandidate);
            this.subscribers[this.subscribers.length - 1].update(this.current);
            return sub;
        };
        ValueReaction.prototype.getSingleVelocity = function (current, prev) {
            return typeof current === 'number' && typeof prev === 'number' ? velocityPerSecond(current - prev, this.timeDelta) : velocityPerSecond(parseFloat(current) - parseFloat(prev), this.timeDelta) || 0;
        };
        ValueReaction.prototype.getListVelocity = function () {
            var _this = this;
            return this.current.map(function (c, i) {
                return _this.getSingleVelocity(c, _this.prev[i]);
            });
        };
        ValueReaction.prototype.getMapVelocity = function () {
            var velocity = {};
            for (var key in this.current) {
                if (this.current.hasOwnProperty(key)) {
                    velocity[key] = this.getSingleVelocity(this.current[key], this.prev[key]);
                }
            }
            return velocity;
        };
        return ValueReaction;
    }(BaseMulticast);
    var value = function (value, initialSubscription) {
        return new ValueReaction({ value: value, initialSubscription: initialSubscription });
    };

    var multi = function (_a) {
        var getCount = _a.getCount,
            getFirst = _a.getFirst,
            getOutput = _a.getOutput,
            mapApi = _a.mapApi,
            setProp = _a.setProp,
            startActions = _a.startActions;
        return function (actions) {
            return action(function (_a) {
                var update = _a.update,
                    complete = _a.complete,
                    error = _a.error;
                var numActions = getCount(actions);
                var output = getOutput();
                var updateOutput = function () {
                    return update(output);
                };
                var numCompletedActions = 0;
                var subs = startActions(actions, function (a, name) {
                    var hasCompleted = false;
                    return a.start({
                        complete: function () {
                            if (!hasCompleted) {
                                hasCompleted = true;
                                numCompletedActions++;
                                if (numCompletedActions === numActions) sync.update(complete);
                            }
                        },
                        error: error,
                        update: function (v) {
                            setProp(output, name, v);
                            sync.update(updateOutput, false, true);
                        }
                    });
                });
                return Object.keys(getFirst(subs)).reduce(function (api, methodName) {
                    api[methodName] = mapApi(subs, methodName);
                    return api;
                }, {});
            });
        };
    };

    var composite = /*#__PURE__*/multi({
        getOutput: function () {
            return {};
        },
        getCount: function (subs) {
            return Object.keys(subs).length;
        },
        getFirst: function (subs) {
            return subs[Object.keys(subs)[0]];
        },
        mapApi: function (subs, methodName) {
            return function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return Object.keys(subs).reduce(function (output, propKey) {
                    var _a;
                    if (subs[propKey][methodName]) {
                        args[0] && args[0][propKey] !== undefined ? output[propKey] = subs[propKey][methodName](args[0][propKey]) : output[propKey] = (_a = subs[propKey])[methodName].apply(_a, args);
                    }
                    return output;
                }, {});
            };
        },
        setProp: function (output, name, v) {
            return output[name] = v;
        },
        startActions: function (actions, starter) {
            return Object.keys(actions).reduce(function (subs, key) {
                subs[key] = starter(actions[key], key);
                return subs;
            }, {});
        }
    });

    var parallel = /*#__PURE__*/multi({
        getOutput: function () {
            return [];
        },
        getCount: function (subs) {
            return subs.length;
        },
        getFirst: function (subs) {
            return subs[0];
        },
        mapApi: function (subs, methodName) {
            return function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return subs.map(function (sub, i) {
                    if (sub[methodName]) {
                        return Array.isArray(args[0]) ? sub[methodName](args[0][i]) : sub[methodName].apply(sub, args);
                    }
                });
            };
        },
        setProp: function (output, name, v) {
            return output[name] = v;
        },
        startActions: function (actions, starter) {
            return actions.map(function (action, i) {
                return starter(action, i);
            });
        }
    });
    var parallel$1 = function () {
        var actions = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            actions[_i] = arguments[_i];
        }
        return parallel(actions);
    };

    var createVectorTests = function (typeTests) {
        var testNames = Object.keys(typeTests);
        var isVectorProp = function (prop, key) {
            return prop !== undefined && !typeTests[key](prop);
        };
        var getVectorKeys = function (props) {
            return testNames.reduce(function (vectorKeys, key) {
                if (isVectorProp(props[key], key)) vectorKeys.push(key);
                return vectorKeys;
            }, []);
        };
        var testVectorProps = function (props) {
            return props && testNames.some(function (key) {
                return isVectorProp(props[key], key);
            });
        };
        return { getVectorKeys: getVectorKeys, testVectorProps: testVectorProps };
    };
    var unitTypes = [px, percent, degrees, vh, vw];
    var findUnitType = function (prop) {
        return unitTypes.find(function (type) {
            return type.test(prop);
        });
    };
    var isUnitProp = function (prop) {
        return Boolean(findUnitType(prop));
    };
    var createAction = function (action, props) {
        return action(props);
    };
    var reduceArrayValue = function (i) {
        return function (props, key) {
            props[key] = props[key][i];
            return props;
        };
    };
    var createArrayAction = function (action, props, vectorKeys) {
        var firstVectorKey = vectorKeys[0];
        var actionList = props[firstVectorKey].map(function (v, i) {
            var childActionProps = vectorKeys.reduce(reduceArrayValue(i), __assign({}, props));
            return getActionCreator(v)(action, childActionProps);
        });
        return parallel$1.apply(void 0, actionList);
    };
    var reduceObjectValue = function (key) {
        return function (props, propKey) {
            props[propKey] = props[propKey][key];
            return props;
        };
    };
    var createObjectAction = function (action, props, vectorKeys) {
        var firstVectorKey = vectorKeys[0];
        var actionMap = Object.keys(props[firstVectorKey]).reduce(function (map, key) {
            var childActionProps = vectorKeys.reduce(reduceObjectValue(key), __assign({}, props));
            map[key] = getActionCreator(props[firstVectorKey][key])(action, childActionProps);
            return map;
        }, {});
        return composite(actionMap);
    };
    var createUnitAction = function (action, _a) {
        var from = _a.from,
            to = _a.to,
            props = __rest(_a, ["from", "to"]);
        var unitType = findUnitType(from) || findUnitType(to);
        var transform = unitType.transform,
            parse = unitType.parse;
        return action(__assign({}, props, { from: typeof from === 'string' ? parse(from) : from, to: typeof to === 'string' ? parse(to) : to })).pipe(transform);
    };
    var createColorAction = function (action, _a) {
        var from = _a.from,
            to = _a.to,
            props = __rest(_a, ["from", "to"]);
        return action(__assign({}, props, { from: 0, to: 1 })).pipe(mixColor(from, to), color.transform);
    };
    var createComplexAction = function (action, _a) {
        var from = _a.from,
            to = _a.to,
            props = __rest(_a, ["from", "to"]);
        var valueTemplate = complex.createTransformer(from);
        invariant(valueTemplate(from) === complex.createTransformer(to)(from), "Values '" + from + "' and '" + to + "' are of different format, or a value might have changed value type.");
        return action(__assign({}, props, { from: 0, to: 1 })).pipe(mixArray(complex.parse(from), complex.parse(to)), valueTemplate);
    };
    var createVectorAction = function (action, typeTests) {
        var _a = createVectorTests(typeTests),
            testVectorProps = _a.testVectorProps,
            getVectorKeys = _a.getVectorKeys;
        var vectorAction = function (props) {
            var isVector = testVectorProps(props);
            if (!isVector) return action(props);
            var vectorKeys = getVectorKeys(props);
            var testKey = vectorKeys[0];
            var testProp = props[testKey];
            return getActionCreator(testProp)(action, props, vectorKeys);
        };
        return vectorAction;
    };
    var getActionCreator = function (prop) {
        var actionCreator = createAction;
        if (typeof prop === 'number') {
            actionCreator = createAction;
        } else if (Array.isArray(prop)) {
            actionCreator = createArrayAction;
        } else if (isUnitProp(prop)) {
            actionCreator = createUnitAction;
        } else if (color.test(prop)) {
            actionCreator = createColorAction;
        } else if (complex.test(prop)) {
            actionCreator = createComplexAction;
        } else if (typeof prop === 'object') {
            actionCreator = createObjectAction;
        }
        return actionCreator;
    };

    var decay = function (props) {
        if (props === void 0) {
            props = {};
        }
        return action(function (_a) {
            var complete = _a.complete,
                update = _a.update;
            var _b = props.velocity,
                velocity = _b === void 0 ? 0 : _b,
                _c = props.from,
                from = _c === void 0 ? 0 : _c,
                _d = props.power,
                power = _d === void 0 ? 0.8 : _d,
                _e = props.timeConstant,
                timeConstant = _e === void 0 ? 350 : _e,
                _f = props.restDelta,
                restDelta = _f === void 0 ? 0.5 : _f,
                modifyTarget = props.modifyTarget;
            var elapsed = 0;
            var amplitude = power * velocity;
            var idealTarget = Math.round(from + amplitude);
            var target = typeof modifyTarget === 'undefined' ? idealTarget : modifyTarget(idealTarget);
            var process = sync.update(function (_a) {
                var frameDelta = _a.delta;
                elapsed += frameDelta;
                var delta = -amplitude * Math.exp(-elapsed / timeConstant);
                var isMoving = delta > restDelta || delta < -restDelta;
                var current = isMoving ? target + delta : target;
                update(current);
                if (!isMoving) {
                    cancelSync.update(process);
                    complete();
                }
            }, true);
            return {
                stop: function () {
                    return cancelSync.update(process);
                }
            };
        });
    };
    var vectorDecay = /*#__PURE__*/createVectorAction(decay, {
        from: number.test,
        modifyTarget: function (func) {
            return typeof func === 'function';
        },
        velocity: number.test
    });

    var spring = function (props) {
        if (props === void 0) {
            props = {};
        }
        return action(function (_a) {
            var update = _a.update,
                complete = _a.complete;
            var _b = props.velocity,
                velocity = _b === void 0 ? 0.0 : _b;
            var _c = props.from,
                from = _c === void 0 ? 0.0 : _c,
                _d = props.to,
                to = _d === void 0 ? 0.0 : _d,
                _e = props.stiffness,
                stiffness = _e === void 0 ? 100 : _e,
                _f = props.damping,
                damping = _f === void 0 ? 10 : _f,
                _g = props.mass,
                mass = _g === void 0 ? 1.0 : _g,
                _h = props.restSpeed,
                restSpeed = _h === void 0 ? 0.01 : _h,
                _j = props.restDelta,
                restDelta = _j === void 0 ? 0.01 : _j;
            var initialVelocity = velocity ? -(velocity / 1000) : 0.0;
            var t = 0;
            var delta = to - from;
            var position = from;
            var prevPosition = position;
            var process = sync.update(function (_a) {
                var timeDelta = _a.delta;
                t += timeDelta;
                var dampingRatio = damping / (2 * Math.sqrt(stiffness * mass));
                var angularFreq = Math.sqrt(stiffness / mass) / 1000;
                prevPosition = position;
                if (dampingRatio < 1) {
                    var envelope = Math.exp(-dampingRatio * angularFreq * t);
                    var expoDecay = angularFreq * Math.sqrt(1.0 - dampingRatio * dampingRatio);
                    position = to - envelope * ((initialVelocity + dampingRatio * angularFreq * delta) / expoDecay * Math.sin(expoDecay * t) + delta * Math.cos(expoDecay * t));
                } else {
                    var envelope = Math.exp(-angularFreq * t);
                    position = to - envelope * (delta + (initialVelocity + angularFreq * delta) * t);
                }
                velocity = velocityPerSecond(position - prevPosition, timeDelta);
                var isBelowVelocityThreshold = Math.abs(velocity) <= restSpeed;
                var isBelowDisplacementThreshold = Math.abs(to - position) <= restDelta;
                if (isBelowVelocityThreshold && isBelowDisplacementThreshold) {
                    position = to;
                    update(position);
                    cancelSync.update(process);
                    complete();
                } else {
                    update(position);
                }
            }, true);
            return {
                stop: function () {
                    return cancelSync.update(process);
                }
            };
        });
    };
    var vectorSpring = /*#__PURE__*/createVectorAction(spring, {
        from: number.test,
        to: number.test,
        stiffness: number.test,
        damping: number.test,
        mass: number.test,
        velocity: number.test
    });

    var inertia = function (_a) {
        var _b = _a.from,
            from = _b === void 0 ? 0 : _b,
            _c = _a.velocity,
            velocity = _c === void 0 ? 0 : _c,
            min = _a.min,
            max = _a.max,
            _d = _a.power,
            power = _d === void 0 ? 0.8 : _d,
            _e = _a.timeConstant,
            timeConstant = _e === void 0 ? 700 : _e,
            _f = _a.bounceStiffness,
            bounceStiffness = _f === void 0 ? 500 : _f,
            _g = _a.bounceDamping,
            bounceDamping = _g === void 0 ? 10 : _g,
            _h = _a.restDelta,
            restDelta = _h === void 0 ? 1 : _h,
            modifyTarget = _a.modifyTarget;
        return action(function (_a) {
            var update = _a.update,
                complete = _a.complete;
            var current = value(from);
            var activeAnimation;
            var isSpring = false;
            var isLessThanMin = function (v) {
                return min !== undefined && v <= min;
            };
            var isMoreThanMax = function (v) {
                return max !== undefined && v >= max;
            };
            var isOutOfBounds = function (v) {
                return isLessThanMin(v) || isMoreThanMax(v);
            };
            var isTravellingAwayFromBounds = function (v, currentVelocity) {
                return isLessThanMin(v) && currentVelocity < 0 || isMoreThanMax(v) && currentVelocity > 0;
            };
            var startAnimation = function (animation, onComplete) {
                activeAnimation && activeAnimation.stop();
                activeAnimation = animation.start({
                    update: function (v) {
                        return current.update(v);
                    },
                    complete: function () {
                        complete();
                        onComplete && onComplete();
                    }
                });
            };
            var startSpring = function (props) {
                isSpring = true;
                startAnimation(vectorSpring(__assign({}, props, { to: isLessThanMin(props.from) ? min : max, stiffness: bounceStiffness, damping: bounceDamping, restDelta: restDelta })));
            };
            current.subscribe(function (v) {
                update(v);
                var currentVelocity = current.getVelocity();
                if (activeAnimation && !isSpring && isTravellingAwayFromBounds(v, currentVelocity)) {
                    startSpring({ from: v, velocity: currentVelocity });
                }
            });
            if (isOutOfBounds(from) && velocity === 0 || isTravellingAwayFromBounds(from, velocity)) {
                startSpring({ from: from, velocity: velocity });
            } else {
                var animation = vectorDecay({
                    from: from,
                    velocity: velocity,
                    timeConstant: timeConstant,
                    power: power,
                    restDelta: isOutOfBounds(from) ? 20 : restDelta,
                    modifyTarget: modifyTarget
                });
                startAnimation(animation, function () {
                    var v = current.get();
                    if (isOutOfBounds(v)) {
                        startSpring({ from: v, velocity: current.getVelocity() });
                    }
                });
            }
            return {
                stop: function () {
                    return activeAnimation && activeAnimation.stop();
                }
            };
        });
    };
    var index$1 = /*#__PURE__*/createVectorAction(inertia, {
        from: number.test,
        velocity: number.test,
        min: number.test,
        max: number.test,
        damping: number.test,
        stiffness: number.test,
        modifyTarget: function (func) {
            return typeof func === 'function';
        }
    });

    var scrubber = function (_a) {
        var _b = _a.from,
            from = _b === void 0 ? 0 : _b,
            _c = _a.to,
            to = _c === void 0 ? 1 : _c,
            _d = _a.ease,
            ease = _d === void 0 ? linear : _d;
        return action(function (_a) {
            var update = _a.update;
            return {
                seek: function (progress$$1) {
                    return update(progress$$1);
                }
            };
        }).pipe(ease, function (v) {
            return mix(from, to, v);
        });
    };
    var vectorScrubber = /*#__PURE__*/createVectorAction(scrubber, {
        ease: function (func) {
            return typeof func === 'function';
        },
        from: number.test,
        to: number.test
    });

    var clampProgress$1 = /*#__PURE__*/clamp$1$1(0, 1);
    var tween = function (props) {
        if (props === void 0) {
            props = {};
        }
        return action(function (_a) {
            var update = _a.update,
                complete = _a.complete;
            var _b = props.duration,
                duration = _b === void 0 ? 300 : _b,
                _c = props.ease,
                ease = _c === void 0 ? easeOut : _c,
                _d = props.flip,
                flip = _d === void 0 ? 0 : _d,
                _e = props.loop,
                loop = _e === void 0 ? 0 : _e,
                _f = props.yoyo,
                yoyo = _f === void 0 ? 0 : _f;
            var _g = props.from,
                from = _g === void 0 ? 0 : _g,
                _h = props.to,
                to = _h === void 0 ? 1 : _h,
                _j = props.elapsed,
                elapsed = _j === void 0 ? 0 : _j,
                _k = props.playDirection,
                playDirection = _k === void 0 ? 1 : _k,
                _l = props.flipCount,
                flipCount = _l === void 0 ? 0 : _l,
                _m = props.yoyoCount,
                yoyoCount = _m === void 0 ? 0 : _m,
                _o = props.loopCount,
                loopCount = _o === void 0 ? 0 : _o;
            var playhead = vectorScrubber({ from: from, to: to, ease: ease }).start(update);
            var currentProgress = 0;
            var process;
            var isActive = false;
            var reverseTween = function () {
                return playDirection *= -1;
            };
            var isTweenComplete = function () {
                var _a;
                var isComplete = playDirection === 1 ? isActive && elapsed >= duration : isActive && elapsed <= 0;
                if (!isComplete) return false;
                if (isComplete && !loop && !flip && !yoyo) return true;
                var isStepTaken = false;
                if (loop && loopCount < loop) {
                    elapsed = 0;
                    loopCount++;
                    isStepTaken = true;
                } else if (flip && flipCount < flip) {
                    elapsed = duration - elapsed;
                    _a = [to, from], from = _a[0], to = _a[1];
                    playhead = vectorScrubber({ from: from, to: to, ease: ease }).start(update);
                    flipCount++;
                    isStepTaken = true;
                } else if (yoyo && yoyoCount < yoyo) {
                    reverseTween();
                    yoyoCount++;
                    isStepTaken = true;
                }
                return !isStepTaken;
            };
            var updateTween = function () {
                currentProgress = clampProgress$1(progress(0, duration, elapsed));
                playhead.seek(currentProgress);
            };
            var startTimer = function () {
                isActive = true;
                process = sync.update(function (_a) {
                    var delta = _a.delta;
                    elapsed += delta * playDirection;
                    updateTween();
                    if (isTweenComplete() && complete) {
                        cancelSync.update(process);
                        sync.update(complete, false, true);
                    }
                }, true);
            };
            var stopTimer = function () {
                isActive = false;
                if (process) cancelSync.update(process);
            };
            startTimer();
            return {
                isActive: function () {
                    return isActive;
                },
                getElapsed: function () {
                    return clamp$1$1(0, duration, elapsed);
                },
                getProgress: function () {
                    return currentProgress;
                },
                stop: function () {
                    stopTimer();
                },
                pause: function () {
                    stopTimer();
                    return this;
                },
                resume: function () {
                    if (!isActive) startTimer();
                    return this;
                },
                seek: function (newProgress) {
                    elapsed = mix(0, duration, newProgress);
                    sync.update(updateTween, false, true);
                    return this;
                },
                reverse: function () {
                    reverseTween();
                    return this;
                }
            };
        });
    };

    var clampProgress$1$1 = /*#__PURE__*/clamp$1$1(0, 1);
    var defaultEasings = function (values, easing$$1) {
        return values.map(function () {
            return easing$$1 || easeOut;
        }).splice(0, values.length - 1);
    };
    var defaultTimings = function (values) {
        var numValues = values.length;
        return values.map(function (value, i) {
            return i !== 0 ? i / (numValues - 1) : 0;
        });
    };
    var interpolateScrubbers = function (input, scrubbers, update) {
        var rangeLength = input.length;
        var finalInputIndex = rangeLength - 1;
        var finalScrubberIndex = finalInputIndex - 1;
        var subs = scrubbers.map(function (scrub) {
            return scrub.start(update);
        });
        return function (v) {
            if (v <= input[0]) {
                subs[0].seek(0);
            }
            if (v >= input[finalInputIndex]) {
                subs[finalScrubberIndex].seek(1);
            }
            var i = 1;
            for (; i < rangeLength; i++) {
                if (input[i] > v || i === finalInputIndex) break;
            }
            var progressInRange = progress(input[i - 1], input[i], v);
            subs[i - 1].seek(clampProgress$1$1(progressInRange));
        };
    };
    var keyframes = function (_a) {
        var easings = _a.easings,
            _b = _a.ease,
            ease = _b === void 0 ? linear : _b,
            times = _a.times,
            values = _a.values,
            tweenProps = __rest(_a, ["easings", "ease", "times", "values"]);
        easings = Array.isArray(easings) ? easings : defaultEasings(values, easings);
        times = times || defaultTimings(values);
        var scrubbers = easings.map(function (easing$$1, i) {
            return vectorScrubber({
                from: values[i],
                to: values[i + 1],
                ease: easing$$1
            });
        });
        return tween(__assign({}, tweenProps, { ease: ease })).applyMiddleware(function (update) {
            return interpolateScrubbers(times, scrubbers, update);
        });
    };

    var physics = function (props) {
        if (props === void 0) {
            props = {};
        }
        return action(function (_a) {
            var complete = _a.complete,
                update = _a.update;
            var _b = props.acceleration,
                acceleration = _b === void 0 ? 0 : _b,
                _c = props.friction,
                friction = _c === void 0 ? 0 : _c,
                _d = props.velocity,
                velocity = _d === void 0 ? 0 : _d,
                springStrength = props.springStrength,
                to = props.to;
            var _e = props.restSpeed,
                restSpeed = _e === void 0 ? 0.001 : _e,
                _f = props.from,
                from = _f === void 0 ? 0 : _f;
            var current = from;
            var process = sync.update(function (_a) {
                var delta = _a.delta;
                var elapsed = Math.max(delta, 16);
                if (acceleration) velocity += velocityPerFrame(acceleration, elapsed);
                if (friction) velocity *= Math.pow(1 - friction, elapsed / 100);
                if (springStrength !== undefined && to !== undefined) {
                    var distanceToTarget = to - current;
                    velocity += distanceToTarget * velocityPerFrame(springStrength, elapsed);
                }
                current += velocityPerFrame(velocity, elapsed);
                update(current);
                var isComplete = restSpeed !== false && (!velocity || Math.abs(velocity) <= restSpeed);
                if (isComplete) {
                    cancelSync.update(process);
                    complete();
                }
            }, true);
            return {
                set: function (v) {
                    current = v;
                    return this;
                },
                setAcceleration: function (v) {
                    acceleration = v;
                    return this;
                },
                setFriction: function (v) {
                    friction = v;
                    return this;
                },
                setSpringStrength: function (v) {
                    springStrength = v;
                    return this;
                },
                setSpringTarget: function (v) {
                    to = v;
                    return this;
                },
                setVelocity: function (v) {
                    velocity = v;
                    return this;
                },
                stop: function () {
                    return cancelSync.update(process);
                }
            };
        });
    };
    var vectorPhysics = /*#__PURE__*/createVectorAction(physics, {
        acceleration: number.test,
        friction: number.test,
        velocity: number.test,
        from: number.test,
        to: number.test,
        springStrength: number.test
    });

    var listen = function (element, events, options) {
        return action(function (_a) {
            var update = _a.update;
            var eventNames = events.split(' ').map(function (eventName) {
                element.addEventListener(eventName, update, options);
                return eventName;
            });
            return {
                stop: function () {
                    return eventNames.forEach(function (eventName) {
                        return element.removeEventListener(eventName, update, options);
                    });
                }
            };
        });
    };

    var defaultPointerPos = function () {
        return {
            clientX: 0,
            clientY: 0,
            pageX: 0,
            pageY: 0,
            x: 0,
            y: 0
        };
    };
    var eventToPoint = function (e, point) {
        if (point === void 0) {
            point = defaultPointerPos();
        }
        point.clientX = point.x = e.clientX;
        point.clientY = point.y = e.clientY;
        point.pageX = e.pageX;
        point.pageY = e.pageY;
        return point;
    };

    var points = [/*#__PURE__*/defaultPointerPos()];
    if (typeof document !== 'undefined') {
        var updatePointsLocation = function (_a) {
            var touches = _a.touches;
            var numTouches = touches.length;
            points.length = 0;
            for (var i = 0; i < numTouches; i++) {
                var thisTouch = touches[i];
                points.push(eventToPoint(thisTouch));
            }
        };
        listen(document, 'touchstart touchmove', {
            passive: true,
            capture: true
        }).start(updatePointsLocation);
    }

    var point = /*#__PURE__*/defaultPointerPos();
    if (typeof document !== 'undefined') {
        var updatePointLocation = function (e) {
            eventToPoint(e, point);
        };
        listen(document, 'mousedown mousemove', true).start(updatePointLocation);
    }

    var chain = function () {
        var actions = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            actions[_i] = arguments[_i];
        }
        return action(function (_a) {
            var update = _a.update,
                complete = _a.complete;
            var i = 0;
            var current;
            var playCurrent = function () {
                current = actions[i].start({
                    complete: function () {
                        i++;
                        i >= actions.length ? complete() : playCurrent();
                    },
                    update: update
                });
            };
            playCurrent();
            return {
                stop: function () {
                    return current && current.stop();
                }
            };
        });
    };

    var delay = function (timeToDelay) {
        return action(function (_a) {
            var complete = _a.complete;
            var timeout = setTimeout(complete, timeToDelay);
            return {
                stop: function () {
                    return clearTimeout(timeout);
                }
            };
        });
    };

    var appendUnit = function (unit) {
        return function (v) {
            return "" + v + unit;
        };
    };
    var steps$2 = function (st, min, max) {
        if (min === void 0) {
            min = 0;
        }
        if (max === void 0) {
            max = 1;
        }
        return function (v) {
            var current = progress(min, max, v);
            return mix(min, max, stepProgress(st, current));
        };
    };
    var transformMap = function (childTransformers) {
        return function (v) {
            var output = __assign({}, v);
            for (var key in childTransformers) {
                if (childTransformers.hasOwnProperty(key)) {
                    var childTransformer = childTransformers[key];
                    output[key] = childTransformer(v[key]);
                }
            }
            return output;
        };
    };

    var transformers = /*#__PURE__*/Object.freeze({
        applyOffset: applyOffset,
        clamp: clamp$1$1,
        conditional: conditional,
        interpolate: interpolate,
        blendArray: mixArray,
        blendColor: mixColor,
        pipe: pipe,
        smooth: smooth,
        snap: snap,
        generateStaticSpring: springForce,
        nonlinearSpring: springForceExpo,
        linearSpring: springForceLinear,
        wrap: wrap$1,
        appendUnit: appendUnit,
        steps: steps$2,
        transformMap: transformMap
    });

    var isFloat = function (value$$1) {
        return !isNaN(parseFloat(value$$1));
    };
    var MotionValue = (function () {
        function MotionValue(init, _a) {
            var _b = _a === void 0 ? {} : _a, transformer = _b.transformer, parent = _b.parent;
            var _this = this;
            this.timeDelta = 0;
            this.lastUpdated = 0;
            this.canTrackVelocity = false;
            this.notifySubscriber = function (subscriber) {
                subscriber(_this.current);
            };
            this.scheduleVelocityCheck = function () { return sync.postRender(_this.velocityCheck); };
            this.velocityCheck = function (_a) {
                var timestamp = _a.timestamp;
                if (timestamp !== _this.lastUpdated) {
                    _this.prev = _this.current;
                }
            };
            this.setChild = function (child) { return child.set(_this.current); };
            this.parent = parent;
            this.transformer = transformer;
            this.set(init);
            this.canTrackVelocity = isFloat(this.current);
        }
        MotionValue.prototype.addChild = function (config) {
            var child = new MotionValue(this.current, __assign({ parent: this }, config));
            if (!this.children)
                this.children = new Set();
            this.children.add(child);
            return child;
        };
        MotionValue.prototype.removeChild = function (child) {
            if (!this.children) {
                return;
            }
            this.children.delete(child);
        };
        MotionValue.prototype.subscribeTo = function (subscriptions, subscription) {
            var _this = this;
            var updateSubscriber = function () { return subscription(_this.current); };
            subscriptions.add(updateSubscriber);
            return function () { return subscriptions.delete(updateSubscriber); };
        };
        MotionValue.prototype.addUpdateSubscription = function (subscription) {
            if (!this.updateSubscribers)
                this.updateSubscribers = new Set();
            return this.subscribeTo(this.updateSubscribers, subscription);
        };
        MotionValue.prototype.addRenderSubscription = function (subscription) {
            if (!this.renderSubscribers)
                this.renderSubscribers = new Set();
            return this.subscribeTo(this.renderSubscribers, subscription);
        };
        MotionValue.prototype.set = function (v, render) {
            if (render === void 0) { render = true; }
            this.prev = this.current;
            this.current = this.transformer ? this.transformer(v) : v;
            if (this.updateSubscribers) {
                this.updateSubscribers.forEach(this.notifySubscriber);
            }
            if (this.children) {
                this.children.forEach(this.setChild);
            }
            if (render && this.renderSubscribers) {
                this.renderSubscribers.forEach(this.notifySubscriber);
            }
            var _a = getFrameData(), delta = _a.delta, timestamp = _a.timestamp;
            if (this.lastUpdated !== timestamp) {
                this.timeDelta = delta;
                this.lastUpdated = timestamp;
                sync.postRender(this.scheduleVelocityCheck);
            }
        };
        MotionValue.prototype.get = function () {
            return this.current;
        };
        MotionValue.prototype.getVelocity = function () {
            return this.canTrackVelocity
                ?
                    velocityPerSecond(parseFloat(this.current) -
                        parseFloat(this.prev), this.timeDelta)
                : 0;
        };
        MotionValue.prototype.control = function (controller, _a, transformer) {
            var _this = this;
            var delay$$1 = _a.delay, config = __rest(_a, ["delay"]);
            this.stop();
            var initialisedController = controller(__assign({ from: this.get(), velocity: this.getVelocity() }, config));
            if (transformer) {
                initialisedController = initialisedController.pipe(transformer);
            }
            if (delay$$1) {
                initialisedController = chain(delay(delay$$1), initialisedController);
            }
            return new Promise(function (complete) {
                _this.controller = initialisedController.start({
                    update: function (v) { return _this.set(v); },
                    complete: complete,
                });
            });
        };
        MotionValue.prototype.stop = function () {
            if (this.controller)
                this.controller.stop();
        };
        MotionValue.prototype.destroy = function () {
            this.updateSubscribers && this.updateSubscribers.clear();
            this.renderSubscribers && this.renderSubscribers.clear();
            this.parent && this.parent.removeChild(this);
            this.stop();
        };
        return MotionValue;
    }());
    var motionValue = function (init, opts) {
        return new MotionValue(init, opts);
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign$4 = function () {
        __assign$4 = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign$4.apply(this, arguments);
    };

    function __rest$2(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
        return t;
    }

    var createStyler$1 = function (_a) {
        var onRead = _a.onRead,
            onRender = _a.onRender,
            _b = _a.uncachedValues,
            uncachedValues = _b === void 0 ? new Set() : _b,
            _c = _a.useCache,
            useCache = _c === void 0 ? true : _c;
        return function (props) {
            var state = {};
            var changedValues = [];
            var hasChanged = false;
            var setValue = function (key, value) {
                var currentValue = state[key];
                state[key] = value;
                if (state[key] !== currentValue) {
                    if (changedValues.indexOf(key) === -1) {
                        changedValues.push(key);
                    }
                    if (!hasChanged) {
                        hasChanged = true;
                        sync.render(render);
                    }
                }
            };
            function render(forceRender) {
                if (forceRender === void 0) {
                    forceRender = false;
                }
                if (forceRender === true || hasChanged) {
                    onRender(state, props, changedValues);
                    hasChanged = false;
                    changedValues.length = 0;
                }
                return this;
            }
            return {
                get: function (key) {
                    return key ? useCache && !uncachedValues.has(key) && state[key] !== undefined ? state[key] : onRead(key, props) : state;
                },
                set: function (values, value) {
                    if (typeof values === 'string') {
                        if (value !== undefined) {
                            setValue(values, value);
                        } else {
                            return function (v) {
                                return setValue(values, v);
                            };
                        }
                    } else {
                        for (var key in values) {
                            if (values.hasOwnProperty(key)) {
                                setValue(key, values[key]);
                            }
                        }
                    }
                    return this;
                },
                render: render
            };
        };
    };

    var CAMEL_CASE_PATTERN$1 = /([a-z])([A-Z])/g;
    var REPLACE_TEMPLATE$1 = '$1-$2';
    var camelToDash$1 = function (str) {
        return str.replace(CAMEL_CASE_PATTERN$1, REPLACE_TEMPLATE$1).toLowerCase();
    };
    var setDomAttrs$1 = function (element, attrs) {
        for (var key in attrs) {
            if (attrs.hasOwnProperty(key)) {
                element.setAttribute(key, attrs[key]);
            }
        }
    };

    var camelCache$1 = /*#__PURE__*/new Map();
    var dashCache$1 = /*#__PURE__*/new Map();
    var prefixes$1 = ['Webkit', 'Moz', 'O', 'ms', ''];
    var numPrefixes$1 = prefixes$1.length;
    var isBrowser$1 = typeof document !== 'undefined';
    var testElement$1;
    var setDashPrefix$1 = function (key, prefixed) {
        return dashCache$1.set(key, camelToDash$1(prefixed));
    };
    var testPrefix$1 = function (key) {
        testElement$1 = testElement$1 || document.createElement('div');
        for (var i = 0; i < numPrefixes$1; i++) {
            var prefix = prefixes$1[i];
            var noPrefix = prefix === '';
            var prefixedPropertyName = noPrefix ? key : prefix + key.charAt(0).toUpperCase() + key.slice(1);
            if (prefixedPropertyName in testElement$1.style || noPrefix) {
                camelCache$1.set(key, prefixedPropertyName);
                setDashPrefix$1(key, "" + (noPrefix ? '' : '-') + camelToDash$1(prefixedPropertyName));
            }
        }
    };
    var setServerProperty$1 = function (key) {
        return setDashPrefix$1(key, key);
    };
    var prefixer$1 = function (key, asDashCase) {
        if (asDashCase === void 0) {
            asDashCase = false;
        }
        var cache = asDashCase ? dashCache$1 : camelCache$1;
        if (!cache.has(key)) isBrowser$1 ? testPrefix$1(key) : setServerProperty$1(key);
        return cache.get(key) || key;
    };

    var axes$1 = ['', 'X', 'Y', 'Z'];
    var order$1 = ['scale', 'rotate', 'skew', 'transformPerspective'];
    var transformProps$1 = /*#__PURE__*/order$1.reduce(function (acc, key) {
        return axes$1.reduce(function (axesAcc, axesKey) {
            axesAcc.push(key + axesKey);
            return axesAcc;
        }, acc);
    }, ['x', 'y', 'z']);
    var transformPropDictionary$1 = /*#__PURE__*/transformProps$1.reduce(function (dict, key) {
        dict[key] = true;
        return dict;
    }, {});
    var isTransformProp$1 = function (key) {
        return transformPropDictionary$1[key] === true;
    };
    var sortTransformProps$1 = function (a, b) {
        return transformProps$1.indexOf(a) - transformProps$1.indexOf(b);
    };
    var isTransformOriginProp$1 = function (key) {
        return key === 'originX' || key === 'originY';
    };

    var valueTypes$2 = {
        color: color,
        backgroundColor: color,
        outlineColor: color,
        fill: color,
        stroke: color,
        borderColor: color,
        borderTopColor: color,
        borderRightColor: color,
        borderBottomColor: color,
        borderLeftColor: color,
        borderWidth: px,
        borderTopWidth: px,
        borderRightWidth: px,
        borderBottomWidth: px,
        borderLeftWidth: px,
        borderRadius: px,
        borderTopLeftRadius: px,
        borderTopRightRadius: px,
        borderBottomRightRadius: px,
        borderBottomLeftRadius: px,
        width: px,
        maxWidth: px,
        height: px,
        maxHeight: px,
        top: px,
        right: px,
        bottom: px,
        left: px,
        padding: px,
        paddingTop: px,
        paddingRight: px,
        paddingBottom: px,
        paddingLeft: px,
        margin: px,
        marginTop: px,
        marginRight: px,
        marginBottom: px,
        marginLeft: px,
        rotate: degrees,
        rotateX: degrees,
        rotateY: degrees,
        rotateZ: degrees,
        scale: scale,
        scaleX: scale,
        scaleY: scale,
        scaleZ: scale,
        skew: degrees,
        skewX: degrees,
        skewY: degrees,
        distance: px,
        x: px,
        y: px,
        z: px,
        perspective: px,
        opacity: alpha,
        originX: percent,
        originY: percent,
        originZ: px
    };
    var getValueType$2 = function (key) {
        return valueTypes$2[key];
    };

    var SCROLL_LEFT$1 = 'scrollLeft';
    var SCROLL_TOP$1 = 'scrollTop';
    var scrollKeys$1 = /*#__PURE__*/new Set([SCROLL_LEFT$1, SCROLL_TOP$1]);

    var blacklist$1 = /*#__PURE__*/new Set([SCROLL_LEFT$1, SCROLL_TOP$1, 'transform']);
    var aliasMap$1 = {
        x: 'translateX',
        y: 'translateY',
        z: 'translateZ'
    };
    var isCustomTemplate$1 = function (v) {
        return typeof v === 'function';
    };
    var buildStyleProperty$1 = function (state, enableHardwareAcceleration, styles, transform, transformOrigin, transformKeys, isDashCase) {
        if (enableHardwareAcceleration === void 0) {
            enableHardwareAcceleration = true;
        }
        if (styles === void 0) {
            styles = {};
        }
        if (transform === void 0) {
            transform = {};
        }
        if (transformOrigin === void 0) {
            transformOrigin = {};
        }
        if (transformKeys === void 0) {
            transformKeys = [];
        }
        if (isDashCase === void 0) {
            isDashCase = false;
        }
        var transformIsDefault = true;
        var hasTransform = false;
        var hasTransformOrigin = false;
        for (var key in state) {
            var value = state[key];
            var valueType = getValueType$2(key);
            var valueAsType = typeof value === 'number' && valueType ? valueType.transform(value) : value;
            if (isTransformProp$1(key)) {
                hasTransform = true;
                transform[key] = valueAsType;
                transformKeys.push(key);
                if (transformIsDefault) {
                    if (valueType.default && value !== valueType.default || !valueType.default && value !== 0) {
                        transformIsDefault = false;
                    }
                }
            } else if (isTransformOriginProp$1(key)) {
                transformOrigin[key] = valueAsType;
                hasTransformOrigin = true;
            } else if (!blacklist$1.has(key) || !isCustomTemplate$1(valueAsType)) {
                styles[prefixer$1(key, isDashCase)] = valueAsType;
            }
        }
        if (!transformIsDefault) {
            var transformString = '';
            if (isCustomTemplate$1(state.transform)) {
                transformString = state.transform(transform);
            } else {
                var transformHasZ = false;
                transformKeys.sort(sortTransformProps$1);
                var numTransformKeys = transformKeys.length;
                for (var i = 0; i < numTransformKeys; i++) {
                    var key = transformKeys[i];
                    transformString += (aliasMap$1[key] || key) + "(" + transform[key] + ") ";
                    transformHasZ = key === 'z' ? true : transformHasZ;
                }
                if (!transformHasZ && enableHardwareAcceleration) {
                    transformString += 'translateZ(0)';
                } else {
                    transformString = transformString.trim();
                }
            }
            styles.transform = transformString;
        } else if (hasTransform) {
            styles.transform = 'none';
        }
        if (hasTransformOrigin) {
            styles.transformOrigin = (transformOrigin.originX || 0) + " " + (transformOrigin.originY || 0) + " " + (transformOrigin.originZ || 0);
        }
        return styles;
    };
    var createStyleBuilder$1 = function (enableHardwareAcceleration) {
        if (enableHardwareAcceleration === void 0) {
            enableHardwareAcceleration = true;
        }
        var styles = {};
        var transform = {};
        var transformOrigin = {};
        var transformKeys = [];
        return function (state) {
            transformKeys.length = 0;
            buildStyleProperty$1(state, enableHardwareAcceleration, styles, transform, transformOrigin, transformKeys, true);
            return styles;
        };
    };

    var cssStyler$1 = /*#__PURE__*/createStyler$1({
        onRead: function (key, _a) {
            var element = _a.element,
                preparseOutput = _a.preparseOutput;
            var valueType = getValueType$2(key);
            if (isTransformProp$1(key)) {
                return valueType ? valueType.default || 0 : 0;
            } else if (scrollKeys$1.has(key)) {
                return element[key];
            } else {
                var domValue = window.getComputedStyle(element, null).getPropertyValue(prefixer$1(key, true)) || 0;
                return preparseOutput && valueType && valueType.parse ? valueType.parse(domValue) : domValue;
            }
        },
        onRender: function (state, _a, changedValues) {
            var element = _a.element,
                buildStyles = _a.buildStyles;
            Object.assign(element.style, buildStyles(state));
            if (changedValues.indexOf(SCROLL_LEFT$1) !== -1) element.scrollLeft = state.scrollLeft;
            if (changedValues.indexOf(SCROLL_TOP$1) !== -1) element.scrollTop = state.scrollTop;
        },
        uncachedValues: scrollKeys$1
    });
    var css$2 = function (element, _a) {
        if (_a === void 0) {
            _a = {};
        }
        var enableHardwareAcceleration = _a.enableHardwareAcceleration,
            props = __rest$2(_a, ["enableHardwareAcceleration"]);
        return cssStyler$1(__assign$4({ element: element, buildStyles: createStyleBuilder$1(enableHardwareAcceleration), preparseOutput: true }, props));
    };

    var camelCaseAttributes = /*#__PURE__*/new Set(['baseFrequency', 'diffuseConstant', 'kernelMatrix', 'kernelUnitLength', 'keySplines', 'keyTimes', 'limitingConeAngle', 'markerHeight', 'markerWidth', 'numOctaves', 'targetX', 'targetY', 'surfaceScale', 'specularConstant', 'specularExponent', 'stdDeviation', 'tableValues']);

    var ZERO_NOT_ZERO$1 = 0.0000001;
    var percentToPixels$1 = function (percent$$1, length) {
        return percent$$1 / 100 * length + 'px';
    };
    var build$1 = function (state, dimensions, isPath, pathLength) {
        var hasTransform = false;
        var hasDashArray = false;
        var props = {};
        var dashArrayStyles = isPath ? {
            pathLength: '0',
            pathSpacing: "" + pathLength
        } : undefined;
        var scale$$1 = state.scale !== undefined ? state.scale || ZERO_NOT_ZERO$1 : state.scaleX || 1;
        var scaleY = state.scaleY !== undefined ? state.scaleY || ZERO_NOT_ZERO$1 : scale$$1 || 1;
        var transformOriginX = dimensions.width * ((state.originX || 50) / 100) + dimensions.x;
        var transformOriginY = dimensions.height * ((state.originY || 50) / 100) + dimensions.y;
        var scaleTransformX = -transformOriginX * (scale$$1 * 1);
        var scaleTransformY = -transformOriginY * (scaleY * 1);
        var scaleReplaceX = transformOriginX / scale$$1;
        var scaleReplaceY = transformOriginY / scaleY;
        var transform = {
            translate: "translate(" + state.x + ", " + state.y + ") ",
            scale: "translate(" + scaleTransformX + ", " + scaleTransformY + ") scale(" + scale$$1 + ", " + scaleY + ") translate(" + scaleReplaceX + ", " + scaleReplaceY + ") ",
            rotate: "rotate(" + state.rotate + ", " + transformOriginX + ", " + transformOriginY + ") ",
            skewX: "skewX(" + state.skewX + ") ",
            skewY: "skewY(" + state.skewY + ") "
        };
        for (var key in state) {
            if (state.hasOwnProperty(key)) {
                var value = state[key];
                if (isTransformProp$1(key)) {
                    hasTransform = true;
                } else if (isPath && (key === 'pathLength' || key === 'pathSpacing') && typeof value === 'number') {
                    hasDashArray = true;
                    dashArrayStyles[key] = percentToPixels$1(value, pathLength);
                } else if (isPath && key === 'pathOffset') {
                    props['stroke-dashoffset'] = percentToPixels$1(-value, pathLength);
                } else {
                    var attrKey = !camelCaseAttributes.has(key) ? camelToDash$1(key) : key;
                    props[attrKey] = value;
                }
            }
        }
        if (hasDashArray) {
            props['stroke-dasharray'] = dashArrayStyles.pathLength + ' ' + dashArrayStyles.pathSpacing;
        }
        if (hasTransform) {
            props.transform = '';
            for (var key in transform) {
                if (transform.hasOwnProperty(key)) {
                    var defaultValue = key === 'scale' ? '1' : '0';
                    props.transform += transform[key].replace(/undefined/g, defaultValue);
                }
            }
        }
        return props;
    };

    var int = /*#__PURE__*/__assign$4({}, number, { transform: Math.round });
    var valueTypes$1$1 = {
        fill: color,
        stroke: color,
        scale: scale,
        scaleX: scale,
        scaleY: scale,
        opacity: alpha,
        fillOpacity: alpha,
        strokeOpacity: alpha,
        numOctaves: int
    };
    var getValueType$1$1 = function (key) {
        return valueTypes$1$1[key];
    };

    var getDimensions$1 = function (element) {
        return typeof element.getBBox === 'function' ? element.getBBox() : element.getBoundingClientRect();
    };
    var getSVGElementDimensions$1 = function (element) {
        try {
            return getDimensions$1(element);
        } catch (e) {
            return { x: 0, y: 0, width: 0, height: 0 };
        }
    };

    var svgStyler$1 = /*#__PURE__*/createStyler$1({
        onRead: function (key, _a) {
            var element = _a.element;
            if (!isTransformProp$1(key)) {
                return element.getAttribute(key);
            } else {
                var valueType = getValueType$1$1(key);
                return valueType ? valueType.default : 0;
            }
        },
        onRender: function (state, _a) {
            var dimensions = _a.dimensions,
                element = _a.element,
                isPath = _a.isPath,
                pathLength = _a.pathLength;
            setDomAttrs$1(element, build$1(state, dimensions, isPath, pathLength));
        }
    });
    var svg$2 = function (element) {
        var dimensions = getSVGElementDimensions$1(element);
        var props = {
            element: element,
            dimensions: dimensions,
            isPath: false
        };
        if (element.tagName === 'path') {
            props.isPath = true;
            props.pathLength = element.getTotalLength();
        }
        return svgStyler$1(props);
    };

    var viewport$1 = /*#__PURE__*/createStyler$1({
        useCache: false,
        onRead: function (key) {
            return key === 'scrollTop' ? window.pageYOffset : window.pageXOffset;
        },
        onRender: function (_a) {
            var _b = _a.scrollTop,
                scrollTop = _b === void 0 ? 0 : _b,
                _c = _a.scrollLeft,
                scrollLeft = _c === void 0 ? 0 : _c;
            return window.scrollTo(scrollLeft, scrollTop);
        }
    });

    var cache$1 = /*#__PURE__*/new WeakMap();
    var createDOMStyler$1 = function (node, props) {
        var styler;
        if (node instanceof HTMLElement) {
            styler = css$2(node, props);
        } else if (node instanceof SVGElement) {
            styler = svg$2(node);
        } else if (node === window) {
            styler = viewport$1(node);
        }
        invariant(styler !== undefined, 'No valid node provided. Node must be HTMLElement, SVGElement or window.');
        cache$1.set(node, styler);
        return styler;
    };
    var getStyler$1 = function (node, props) {
        return cache$1.has(node) ? cache$1.get(node) : createDOMStyler$1(node, props);
    };
    function index$2(nodeOrSelector, props) {
        var node = typeof nodeOrSelector === 'string' ? document.querySelector(nodeOrSelector) : nodeOrSelector;
        return getStyler$1(node, props);
    }

    var updateStyler = createStyler$1({
        onRead: function () { return null; },
        onRender: function (state, _a) {
            var onUpdate = _a.onUpdate;
            return onUpdate(state);
        },
    });
    var MotionValuesMap = (function () {
        function MotionValuesMap() {
            this.hasMounted = false;
            this.shouldRender = true;
            this.values = new Map();
            this.unsubscribers = new Map();
        }
        MotionValuesMap.prototype.has = function (key) {
            return this.values.has(key);
        };
        MotionValuesMap.prototype.set = function (key, value) {
            this.values.set(key, value);
            if (this.hasMounted)
                this.bindValueToStyler(key, value);
        };
        MotionValuesMap.prototype.get = function (key, defaultValue) {
            var value = this.values.get(key);
            if (value === undefined && defaultValue !== undefined) {
                value = new MotionValue(defaultValue);
                this.set(key, value);
            }
            return value;
        };
        MotionValuesMap.prototype.forEach = function (callback) {
            return this.values.forEach(callback);
        };
        MotionValuesMap.prototype.bindValueToStyler = function (key, value) {
            var _this = this;
            var update = function (v) {
                if (_this.shouldRender) {
                    _this.styler.set(key, v);
                }
                if (_this.onUpdate) {
                    _this.onUpdate.set(key, v);
                }
            };
            var unsubscribe = value.addRenderSubscription(update);
            this.unsubscribers.set(key, unsubscribe);
        };
        MotionValuesMap.prototype.setOnUpdate = function (onUpdate) {
            this.onUpdate = undefined;
            if (onUpdate) {
                this.onUpdate = updateStyler({ onUpdate: onUpdate });
            }
        };
        MotionValuesMap.prototype.setShouldRender = function (render) {
            this.shouldRender = render;
        };
        MotionValuesMap.prototype.mount = function (element) {
            var _this = this;
            this.hasMounted = true;
            this.styler = index$2(element, { preparseOutput: false });
            this.values.forEach(function (value, key) { return _this.bindValueToStyler(key, value); });
        };
        MotionValuesMap.prototype.unmount = function () {
            var _this = this;
            this.values.forEach(function (_value, key) {
                var unsubscribe = _this.unsubscribers.get(key);
                unsubscribe && unsubscribe();
            });
        };
        return MotionValuesMap;
    }());
    var useMotionValues = function (ref, _a) {
        var onUpdate = _a.onUpdate, _b = _a.render, render = _b === void 0 ? true : _b;
        var motionValues = React.useMemo(function () { return new MotionValuesMap(); }, []);
        motionValues.setOnUpdate(onUpdate);
        motionValues.setShouldRender(render);
        React.useEffect(function () {
            invariant(ref.current instanceof Element, "No `ref` found. Ensure components created with `motion.custom` forward refs using `React.forwardRef`");
            motionValues.mount(ref.current);
            return function () { return motionValues.unmount(); };
        });
        return motionValues;
    };

    var underDampedSpring = function () { return ({
        type: "spring",
        stiffness: 500,
        damping: 25,
        restDelta: 0.5,
        restSpeed: 10,
    }); };
    var overDampedSpring = function (to) { return ({
        type: "spring",
        stiffness: 700,
        damping: to === 0 ? 100 : 35,
    }); };
    var linearTween = function () { return ({
        ease: "linear",
        duration: 250,
    }); };
    var defaultTransitions = {
        x: underDampedSpring,
        y: underDampedSpring,
        z: underDampedSpring,
        rotate: underDampedSpring,
        rotateX: underDampedSpring,
        rotateY: underDampedSpring,
        rotateZ: underDampedSpring,
        scaleX: overDampedSpring,
        scaleY: overDampedSpring,
        scale: overDampedSpring,
        opacity: linearTween,
        backgroundColor: linearTween,
        color: linearTween,
        default: overDampedSpring,
    };
    var getDefaultTransition = function (valueKey, to) {
        var transitionFactory = defaultTransitions[valueKey] || defaultTransitions.default;
        return __assign({}, transitionFactory(to), { to: to });
    };

    var just = function (_a) {
        var to = _a.to;
        return action(function (_a) {
            var update = _a.update, complete = _a.complete;
            update(to);
            complete();
        });
    };
    var transitions = { tween: tween, spring: vectorSpring, keyframes: keyframes, decay: vectorDecay, physics: vectorPhysics, inertia: index$1, just: just };
    var linear$1 = linear, easeIn$1 = easeIn, easeOut$1 = easeOut, easeInOut$1 = easeInOut, circIn$1 = circIn, circOut$1 = circOut, circInOut$1 = circInOut, backIn$1 = backIn, backOut$1 = backOut, backInOut$1 = backInOut, anticipate$1 = anticipate;
    var easingLookup = {
        linear: linear$1,
        easeIn: easeIn$1,
        easeOut: easeOut$1,
        easeInOut: easeInOut$1,
        circIn: circIn$1,
        circOut: circOut$1,
        circInOut: circInOut$1,
        backIn: backIn$1,
        backOut: backOut$1,
        backInOut: backInOut$1,
        anticipate: anticipate$1,
    };
    var transitionOptionParser = {
        tween: function (opts) {
            var ease = opts.ease;
            if (Array.isArray(ease)) {
                invariant(ease.length === 4, "Cubic bezier arrays must contain four numerical values.");
                var x1 = ease[0], y1 = ease[1], x2 = ease[2], y2 = ease[3];
                opts.ease = cubicBezier(x1, y1, x2, y2);
            }
            else if (typeof ease === "string") {
                invariant(easingLookup[ease] !== undefined, "Invalid easing type '" + ease + "'");
                opts.ease = easingLookup[ease];
            }
            return opts;
        },
        keyframes: function (_a) {
            var from = _a.from, to = _a.to, opts = __rest(_a, ["from", "to"]);
            return opts;
        },
    };
    var isTransitionDefined = function (_a) {
        var beforeChildren = _a.beforeChildren, afterChildren = _a.afterChildren, delay$$1 = _a.delay, delayChildren = _a.delayChildren, staggerChildren = _a.staggerChildren, staggerDirection = _a.staggerDirection, transition = __rest(_a, ["beforeChildren", "afterChildren", "delay", "delayChildren", "staggerChildren", "staggerDirection"]);
        return Object.keys(transition).length;
    };
    var getTransitionForValue = function (key, to, transitionDefinition) {
        var delay$$1 = transitionDefinition ? transitionDefinition.delay : 0;
        if (transitionDefinition === undefined ||
            !isTransitionDefined(transitionDefinition)) {
            return __assign({ delay: delay$$1 }, getDefaultTransition(key, to));
        }
        var valueTransitionDefinition = transitionDefinition[key] ||
            transitionDefinition.default ||
            transitionDefinition;
        return valueTransitionDefinition.type === false
            ? { type: "just", delay: delay$$1, to: to }
            : __assign({ delay: delay$$1,
                to: to }, valueTransitionDefinition);
    };
    var preprocessOptions = function (type, opts) {
        return transitionOptionParser[type] ? transitionOptionParser[type](opts) : opts;
    };
    var getTransition = function (valueKey, to, transition) {
        var _a = getTransitionForValue(valueKey, to, transition), _b = _a.type, type = _b === void 0 ? "tween" : _b, transitionDefinition = __rest(_a, ["type"]);
        var actionFactory = transitions[type];
        var opts = preprocessOptions(type, transitionDefinition);
        return [actionFactory, opts];
    };

    var auto = {
        test: function (v) { return v === "auto"; },
        parse: function (v) { return v; },
    };
    var valueTypeTests = [number, degrees, percent, px, vw, vh, auto];
    var testValueType = function (v) { return function (type) { return type.test(v); }; };
    var getValueType$3 = function (v) { return valueTypeTests.find(testValueType(v)); };

    var positionalKeys = new Set([
        "width",
        "height",
        "top",
        "left",
        "right",
        "bottom",
        "x",
        "y",
    ]);
    var isPositionalKey = function (key) { return positionalKeys.has(key); };
    var hasPositionalKey = function (target) {
        return Object.keys(target).some(isPositionalKey);
    };
    var setAndResetVelocity = function (value, to) {
        value.set(to, false);
        value.set(to);
    };
    var BoundingBoxDimension;
    (function (BoundingBoxDimension) {
        BoundingBoxDimension["width"] = "width";
        BoundingBoxDimension["height"] = "height";
        BoundingBoxDimension["left"] = "left";
        BoundingBoxDimension["right"] = "right";
        BoundingBoxDimension["top"] = "top";
        BoundingBoxDimension["bottom"] = "bottom";
    })(BoundingBoxDimension || (BoundingBoxDimension = {}));
    var getPosFromMatrix = function (matrix, pos) {
        return parseFloat(matrix.split(", ")[pos]);
    };
    var getTranslateFromMatrix = function (pos2, pos3) { return function (_bbox, _a) {
        var transform = _a.transform;
        if (transform === "none" || !transform)
            return 0;
        var matrix3d = transform.match(/^matrix3d\((.+)\)$/);
        if (matrix3d) {
            return getPosFromMatrix(matrix3d[1], pos3);
        }
        else {
            var matrix = transform.match(/^matrix\((.+)\)$/);
            return getPosFromMatrix(matrix[1], pos2);
        }
    }; };
    var positionalValues = {
        width: function (_a) {
            var width = _a.width;
            return width;
        },
        height: function (_a) {
            var height = _a.height;
            return height;
        },
        top: function (_bbox, _a) {
            var top = _a.top;
            return parseFloat(top);
        },
        left: function (_bbox, _a) {
            var left = _a.left;
            return parseFloat(left);
        },
        bottom: function (_a, _b) {
            var height = _a.height;
            var top = _b.top;
            return parseFloat(top) + height;
        },
        right: function (_a, _b) {
            var width = _a.width;
            var left = _b.left;
            return parseFloat(left) + width;
        },
        x: getTranslateFromMatrix(4, 13),
        y: getTranslateFromMatrix(5, 14),
    };
    var convertChangedValueTypes = function (pose, values, ref, changedKeys) {
        var element = ref.current;
        var elementStyler = index$2(element);
        var originBbox = element.getBoundingClientRect();
        var elementComputedStyle = getComputedStyle(element);
        var top = elementComputedStyle.top, left = elementComputedStyle.left, bottom = elementComputedStyle.bottom, right = elementComputedStyle.right, transform = elementComputedStyle.transform;
        var originComputedStyle = { top: top, left: left, bottom: bottom, right: right, transform: transform };
        elementStyler.render();
        var targetBbox = element.getBoundingClientRect();
        changedKeys.forEach(function (key) {
            var value = values.get(key);
            setAndResetVelocity(value, positionalValues[key](originBbox, originComputedStyle));
            pose[key] = positionalValues[key](targetBbox, elementComputedStyle);
        });
        elementStyler.render();
        return pose;
    };
    var checkAndConvertChangedValueTypes = function (values, ref, target, transitionEnd) {
        if (transitionEnd === void 0) { transitionEnd = {}; }
        transitionEnd = __assign({}, transitionEnd);
        var posePositionalKeys = Object.keys(target).filter(isPositionalKey);
        var changedValueTypeKeys = posePositionalKeys.reduce(function (acc, key) {
            var value = values.get(key);
            var from = value.get();
            var to = target[key];
            var fromType = getValueType$3(from);
            var toType = getValueType$3(to);
            if (fromType !== toType) {
                acc.push(key);
                transitionEnd[key] =
                    transitionEnd[key] !== undefined
                        ? transitionEnd[key]
                        : target[key];
                setAndResetVelocity(value, to);
            }
            return acc;
        }, []);
        return changedValueTypeKeys.length
            ? {
                target: convertChangedValueTypes(target, values, ref, changedValueTypeKeys),
                transitionEnd: transitionEnd,
            }
            : { target: target, transitionEnd: transitionEnd };
    };
    var unitConversion = function (values, ref, target, transitionEnd) {
        return hasPositionalKey(target)
            ? checkAndConvertChangedValueTypes(values, ref, target, transitionEnd)
            : { target: target, transitionEnd: transitionEnd };
    };

    var getCurrent = function (values) {
        var current = {};
        values.forEach(function (value, key) { return (current[key] = value.get()); });
        return current;
    };
    var getVelocity = function (values) {
        var velocity = {};
        values.forEach(function (value, key) { return (velocity[key] = value.getVelocity()); });
        return velocity;
    };
    var isAnimatable = function (value) {
        return typeof value === "number" || complex.test(value);
    };
    var isTargetResolver = function (p) {
        return typeof p === "function";
    };
    var isVariantLabels = function (v) { return Array.isArray(v); };
    var AnimationControls = (function () {
        function AnimationControls(values, ref) {
            var _this = this;
            this.variants = {};
            this.baseTarget = {};
            this.overrides = [];
            this.resolvedOverrides = [];
            this.isAnimating = new Set();
            this.values = values;
            this.ref = ref;
            this.values.forEach(function (value, key) { return (_this.baseTarget[key] = value.get()); });
        }
        AnimationControls.prototype.setProps = function (props) {
            this.props = props;
        };
        AnimationControls.prototype.setVariants = function (variants) {
            if (variants)
                this.variants = variants;
        };
        AnimationControls.prototype.setDefaultTransition = function (transition) {
            if (transition)
                this.defaultTransition = transition;
        };
        AnimationControls.prototype.setValues = function (target, isActive) {
            var _this = this;
            if (isActive === void 0) { isActive = new Set(); }
            return Object.keys(target).forEach(function (key) {
                if (isActive.has(key))
                    return;
                isActive.add(key);
                if (_this.values.has(key)) {
                    var value = _this.values.get(key);
                    value && value.set(target[key]);
                }
                else {
                    _this.values.set(key, motionValue(target[key]));
                }
                _this.baseTarget[key] = target[key];
            });
        };
        AnimationControls.prototype.checkForNewValues = function (target) {
            var _this = this;
            var newValueKeys = Object.keys(target).filter(function (key) { return !_this.values.has(key); });
            if (!newValueKeys.length)
                return;
            var domStyler = index$2(this.ref.current);
            newValueKeys.forEach(function (key) {
                var domValue = domStyler.get(key);
                _this.values.set(key, motionValue(domValue));
                _this.baseTarget[key] = domValue;
            });
        };
        AnimationControls.prototype.resolveVariant = function (variant) {
            if (!variant) {
                return {
                    target: undefined,
                    transition: undefined,
                    transitionEnd: undefined,
                };
            }
            if (isTargetResolver(variant)) {
                variant = variant(this.props, getCurrent(this.values), getVelocity(this.values));
            }
            var transition = variant.transition, transitionEnd = variant.transitionEnd, target = __rest(variant, ["transition", "transitionEnd"]);
            return { transition: transition, transitionEnd: transitionEnd, target: target };
        };
        AnimationControls.prototype.getHighestPriority = function () {
            var highest = 0;
            var numOverrides = this.overrides.length;
            if (!numOverrides)
                return highest;
            for (var i = 0; i < numOverrides; i++) {
                if (this.overrides[i] !== undefined) {
                    highest = i;
                }
            }
            return highest;
        };
        AnimationControls.prototype.clearOverride = function (overrideIndex) {
            var _this = this;
            var override = this.overrides[overrideIndex];
            if (!override)
                return;
            this.overrides[overrideIndex] = undefined;
            var highest = this.getHighestPriority();
            this.resetIsAnimating();
            if (highest >= overrideIndex) {
                var highestOverride = this.overrides[highest];
                highestOverride &&
                    this.start(highestOverride, { priority: highest });
            }
            var overrideTarget = this.resolvedOverrides[overrideIndex];
            if (!overrideTarget)
                return;
            var remainingValues = Object.keys(this.baseTarget).reduce(function (acc, key) {
                if (overrideTarget[key] !== undefined) {
                    acc[key] = _this.baseTarget[key];
                }
                return acc;
            }, {});
            this.animate(remainingValues);
        };
        AnimationControls.prototype.apply = function (definition) {
            if (Array.isArray(definition)) {
                return this.applyVariantLabels(definition);
            }
            else if (typeof definition === "string") {
                return this.applyVariantLabels([definition]);
            }
            else {
                this.setValues(definition);
            }
        };
        AnimationControls.prototype.applyVariantLabels = function (variantLabelList) {
            var _this = this;
            var isSetting = new Set();
            var reversedList = variantLabelList.slice().reverse();
            reversedList.forEach(function (key) {
                var _a = _this.resolveVariant(_this.variants[key]), target = _a.target, transitionEnd = _a.transitionEnd;
                if (transitionEnd) {
                    _this.setValues(transitionEnd, isSetting);
                }
                if (target) {
                    _this.setValues(target, isSetting);
                }
            });
        };
        AnimationControls.prototype.start = function (definition, opts) {
            if (opts === void 0) { opts = {}; }
            this.setPriorityAnimation(definition, opts.priority || 0);
            this.resetIsAnimating(opts.priority);
            if (isVariantLabels(definition)) {
                return this.animateVariantLabels(definition, opts);
            }
            else if (typeof definition === "string") {
                return this.animateVariant(definition, opts);
            }
            else {
                return this.animate(definition, opts);
            }
        };
        AnimationControls.prototype.setPriorityAnimation = function (definition, priority) {
            this.overrides[priority] = definition;
        };
        AnimationControls.prototype.isHighestPriority = function (priority) {
            var numOverrides = this.overrides.length;
            for (var i = priority + 1; i < numOverrides; i++) {
                if (this.overrides[i] !== undefined) {
                    return false;
                }
            }
            return true;
        };
        AnimationControls.prototype.animate = function (animationDefinition, _a) {
            var _this = this;
            var _b = _a === void 0 ? {} : _a, _c = _b.delay, delay = _c === void 0 ? 0 : _c, _d = _b.priority, priority = _d === void 0 ? 0 : _d;
            var _e = this.resolveVariant(animationDefinition), target = _e.target, transition = _e.transition, transitionEnd = _e.transitionEnd;
            if (!target)
                return Promise.resolve();
            if (priority) {
                this.resolvedOverrides[priority] = target;
            }
            this.checkForNewValues(target);
            var converted = unitConversion(this.values, this.ref, target, transitionEnd);
            target = converted.target;
            transitionEnd = converted.transitionEnd;
            if (!transition && this.defaultTransition) {
                transition = this.defaultTransition;
            }
            var animations = Object.keys(target).reduce(function (acc, key) {
                var value = _this.values.get(key);
                if (_this.isAnimating.has(key) ||
                    !target ||
                    !value ||
                    target[key] === undefined) {
                    return acc;
                }
                var valueTarget = target[key];
                if (!priority) {
                    _this.baseTarget[key] = valueTarget;
                }
                if (isAnimatable(valueTarget)) {
                    var _a = getTransition(key, valueTarget, __assign({ delay: delay }, transition)), action = _a[0], options = _a[1];
                    acc.push(value.control(action, options));
                }
                else {
                    value.set(valueTarget);
                }
                _this.isAnimating.add(key);
                return acc;
            }, []);
            return Promise.all(animations).then(function () {
                if (!transitionEnd)
                    return;
                _this.setValues(transitionEnd);
            });
        };
        AnimationControls.prototype.animateVariantLabels = function (variantLabels, opts) {
            var _this = this;
            var animations = variantLabels.slice().reverse()
                .map(function (label) { return _this.animateVariant(label, opts); });
            return Promise.all(animations);
        };
        AnimationControls.prototype.animateVariant = function (variantLabel, opts) {
            var _this = this;
            var beforeChildren = false;
            var afterChildren = false;
            var delayChildren = 0;
            var staggerChildren = 0;
            var staggerDirection = 1;
            var priority = (opts && opts.priority) || 0;
            var variant = this.variants[variantLabel];
            var getAnimations = variant
                ? function () { return _this.animate(variant, opts); }
                : function () { return Promise.resolve(); };
            var getChildrenAnimations = this.children
                ? function () {
                    return _this.animateChildren(variantLabel, delayChildren, staggerChildren, staggerDirection, priority);
                }
                : function () { return Promise.resolve(); };
            if (variant && this.children) {
                var transition = this.resolveVariant(variant).transition;
                if (transition) {
                    beforeChildren = transition.beforeChildren || beforeChildren;
                    afterChildren = transition.afterChildren || afterChildren;
                    delayChildren = transition.delayChildren || delayChildren;
                    staggerChildren = transition.staggerChildren || staggerChildren;
                    staggerDirection =
                        transition.staggerDirection || staggerDirection;
                }
            }
            if (beforeChildren || afterChildren) {
                var _a = beforeChildren
                    ? [getAnimations, getChildrenAnimations]
                    : [getChildrenAnimations, getAnimations], first = _a[0], last = _a[1];
                return first().then(last);
            }
            else {
                return Promise.all([getAnimations(), getChildrenAnimations()]);
            }
        };
        AnimationControls.prototype.animateChildren = function (variantLabel, delayChildren, staggerChildren, staggerDirection, priority) {
            if (delayChildren === void 0) { delayChildren = 0; }
            if (staggerChildren === void 0) { staggerChildren = 0; }
            if (staggerDirection === void 0) { staggerDirection = 1; }
            if (priority === void 0) { priority = 0; }
            if (!this.children) {
                return Promise.resolve();
            }
            var animations = [];
            var maxStaggerDuration = (this.children.size - 1) * staggerChildren;
            var generateStaggerDuration = staggerDirection === 1
                ? function (i) { return i * staggerChildren; }
                : function (i) { return maxStaggerDuration - i * staggerChildren; };
            Array.from(this.children).forEach(function (childControls, i) {
                var animation = childControls.animateVariant(variantLabel, {
                    priority: priority,
                    delay: delayChildren + generateStaggerDuration(i),
                });
                animations.push(animation);
            });
            return Promise.all(animations);
        };
        AnimationControls.prototype.checkOverrideIsAnimating = function (priority) {
            var numOverrides = this.overrides.length;
            for (var i = priority + 1; i < numOverrides; i++) {
                var resolvedOverride = this.resolvedOverrides[i];
                if (resolvedOverride) {
                    for (var key in resolvedOverride) {
                        this.isAnimating.add(key);
                    }
                }
            }
        };
        AnimationControls.prototype.resetIsAnimating = function (priority) {
            if (priority === void 0) { priority = 0; }
            this.isAnimating.clear();
            if (priority < this.getHighestPriority()) {
                this.checkOverrideIsAnimating(priority);
            }
            if (this.children) {
                this.children.forEach(function (child) { return child.resetIsAnimating(priority); });
            }
        };
        AnimationControls.prototype.stop = function () {
            this.values.forEach(function (value) { return value.stop(); });
        };
        AnimationControls.prototype.addChild = function (controls) {
            if (!this.children) {
                this.children = new Set();
            }
            this.children.add(controls);
        };
        AnimationControls.prototype.removeChild = function (controls) {
            if (!this.children) {
                return;
            }
            this.children.delete(controls);
        };
        AnimationControls.prototype.resetChildren = function () {
            if (this.children)
                this.children.clear();
        };
        return AnimationControls;
    }());
    var useAnimationControls = function (values, props, ref, inherit) {
        var variants = props.variants, transition = props.transition;
        var parentControls = React.useContext(MotionContext).controls;
        var controls = React.useMemo(function () { return new AnimationControls(values, ref); }, []);
        controls.resetChildren();
        if (inherit && parentControls) {
            parentControls.addChild(controls);
        }
        React.useEffect(function () { return function () { return parentControls && parentControls.removeChild(controls); }; }, []);
        controls.setProps(props);
        controls.setVariants(variants);
        controls.setDefaultTransition(transition);
        return controls;
    };

    var useExternalRef = function (external) {
        var ref = !external || typeof external === "function" ? React.useRef(null) : external;
        React.useEffect(function () {
            if (external && typeof external === "function") {
                external(ref.current);
                return function () { return external(null); };
            }
        });
        return ref;
    };

    var createValueResolver = function (resolver) { return function (values) {
        var resolvedValues = {};
        values.forEach(function (value, key) { return (resolvedValues[key] = resolver(value)); });
        return resolvedValues;
    }; };
    var resolveCurrent = createValueResolver(function (value) { return value.get(); });

    var isMotionValue = function (value) { return value instanceof MotionValue; };
    var buildStyleAttr = function (values, styleProp) {
        return __assign({}, styleProp, buildStyleProperty$1(resolveCurrent(values)));
    };
    var addMotionStyles = function (values, styleProp) {
        if (styleProp === void 0) { styleProp = {}; }
        var style = {};
        for (var key in styleProp) {
            var thisStyle = styleProp[key];
            if (isMotionValue(thisStyle)) {
                values.set(key, thisStyle);
            }
            else if (isTransformProp$1(key)) {
                if (!values.has(key)) {
                    values.set(key, motionValue(thisStyle));
                }
            }
            else {
                style[key] = thisStyle;
            }
        }
        return style;
    };

    var AnimationManager = (function () {
        function AnimationManager() {
            this.hasMounted = false;
            this.pendingAnimations = [];
            this.componentControls = new Set();
            this.variants = {};
        }
        AnimationManager.prototype.setVariants = function (variants) {
            this.variants = variants;
            this.componentControls.forEach(function (controls) {
                return controls.setVariants(variants);
            });
        };
        AnimationManager.prototype.setDefaultTransition = function (transition) {
            this.defaultTransition = transition;
            this.componentControls.forEach(function (controls) {
                return controls.setDefaultTransition(transition);
            });
        };
        AnimationManager.prototype.subscribe = function (controls) {
            var _this = this;
            this.componentControls.add(controls);
            if (this.variants)
                controls.setVariants(this.variants);
            if (this.defaultTransition)
                controls.setDefaultTransition(this.defaultTransition);
            return function () { return _this.componentControls.delete(controls); };
        };
        AnimationManager.prototype.start = function (definition) {
            if (this.hasMounted) {
                var animations_1 = [];
                this.componentControls.forEach(function (controls) {
                    var animation = controls.start(definition);
                    animations_1.push(animation);
                });
                return Promise.all(animations_1);
            }
            else {
                this.pendingAnimations.push(definition);
                return Promise.resolve();
            }
        };
        AnimationManager.prototype.stop = function () {
            this.componentControls.forEach(function (controls) { return controls.stop(); });
        };
        AnimationManager.prototype.mount = function () {
            var _this = this;
            this.hasMounted = true;
            this.pendingAnimations.forEach(function (variant) { return _this.start(variant); });
        };
        AnimationManager.prototype.unmount = function () {
            this.hasMounted = false;
            this.stop();
        };
        return AnimationManager;
    }());

    var useAnimationSubscription = function (animation, controls) {
        var unsubscribe = React.useMemo(function () { return animation.subscribe(controls); }, [animation]);
        React.useEffect(function () { return function () { return unsubscribe && unsubscribe(); }; }, [unsubscribe]);
    };

    var poseToArray = function (pose) {
        if (!pose) {
            return [];
        }
        if (Array.isArray(pose)) {
            return pose;
        }
        return [pose];
    };
    var resolvePoses = function (pose) {
        var unresolvedPose = pose instanceof MotionValue ? pose.get() : pose;
        return Array.from(new Set(poseToArray(unresolvedPose)));
    };
    var asDependencyList = function (list) { return [list.join(",")]; };

    var hasVariantChanged = function (oldVariant, newVariant) {
        return oldVariant.join(",") !== newVariant.join(",");
    };
    var useVariants = function (targetVariant, inherit, controls, initialVariant, onAnimationComplete) {
        var variantList = resolvePoses(targetVariant);
        var hasMounted = React.useRef(false);
        React.useEffect(function () {
            if (inherit)
                return;
            if (hasMounted.current || hasVariantChanged(resolvePoses(initialVariant), variantList)) {
                controls.start(variantList).then(function () {
                    onAnimationComplete && onAnimationComplete();
                });
            }
            hasMounted.current = true;
        }, asDependencyList(variantList));
    };

    function isEventTarget(target) {
        return (typeof target.addEventListener === "function" &&
            typeof target.removeEventListener === "function");
    }
    var eventListener = function (target, name, handler, options) {
        var startListening = function () {
            if (!target) {
                return;
            }
            target.addEventListener(name, handler, options);
        };
        var stopListening = function () {
            if (!target) {
                return;
            }
            target.removeEventListener(name, handler, options);
        };
        return [startListening, stopListening];
    };
    var useEvent = function (type, target, handler, options) {
        var result = undefined;
        if ((!target || isEventTarget(target)) && handler) {
            result = eventListener(target, type, handler, options);
        }
        React.useEffect(function () {
            var ref = target;
            if (!handler || !target || isEventTarget(target) || !ref.current) {
                return;
            }
            var _a = eventListener(ref.current, type, handler, options), start = _a[0], stop = _a[1];
            start();
            return stop;
        }, [type, target, handler, options]);
        return result;
    };

    var _TEST_POINTER_DO_NOT_USE = { x: 0, y: 0 };
    var pointForTarget = function (_a, target) {
        var _b = _a.pageX, pageX = _b === void 0 ? _TEST_POINTER_DO_NOT_USE.x : _b, _c = _a.pageY, pageY = _c === void 0 ? _TEST_POINTER_DO_NOT_USE.y : _c;
        if (!target) {
            return { x: pageX, y: pageY };
        }
        if (window.webkitConvertPointFromPageToNode) {
            var webkitPoint = new WebKitPoint(pageX, pageY);
            webkitPoint = window.webkitConvertPointFromPageToNode(target, webkitPoint);
            return { x: webkitPoint.x, y: webkitPoint.y };
        }
        var rect = target.getBoundingClientRect();
        var scaleX = 1;
        if (target.style.width && target.style.width !== "") {
            scaleX = parseFloat(target.style.width) / rect.width;
        }
        var scaleY = 1;
        if (target.style.height && target.style.height !== "") {
            scaleY = parseFloat(target.style.height) / rect.height;
        }
        var point = {
            x: scaleX * (pageX - rect.left - target.clientLeft + target.scrollLeft),
            y: scaleY * (pageY - rect.top - target.clientTop + target.scrollTop),
        };
        return point;
    };
    var extractEventInfo = function (event) {
        var target = event.target instanceof HTMLElement ? event.target : null;
        var point = pointForTarget(event, target);
        var devicePoint = pointForTarget(event, document.body);
        return { point: point, devicePoint: devicePoint };
    };
    var wrapHandler = function (handler) {
        if (!handler) {
            return undefined;
        }
        var listener = function (event, info) {
            if (!info) {
                info = extractEventInfo(event);
            }
            handler(event, info);
        };
        return listener;
    };

    var mergeUseEventResults = function () {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        if (values.every(function (v) { return v === undefined; })) {
            return;
        }
        var start = function () {
            for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
                var value = values_1[_i];
                if (value) {
                    value[0]();
                }
            }
        };
        var stop = function () {
            for (var _i = 0, values_2 = values; _i < values_2.length; _i++) {
                var value = values_2[_i];
                if (value) {
                    value[1]();
                }
            }
        };
        return [start, stop];
    };
    var useMouseEvents = function (_a, ref, options) {
        var onMouseDown = _a.onMouseDown, onMouseMove = _a.onMouseMove, onMouseUp = _a.onMouseUp, onMouseOver = _a.onMouseOver, onMouseOut = _a.onMouseOut, onMouseEnter = _a.onMouseEnter, onMouseLeave = _a.onMouseLeave;
        var down = useEvent("mousedown", ref, wrapHandler(onMouseDown), options);
        var move = useEvent("mousemove", ref, wrapHandler(onMouseMove), options);
        var up = useEvent("mouseup", ref, wrapHandler(onMouseUp), options);
        var over = useEvent("mouseover", ref, wrapHandler(onMouseOver), options);
        var out = useEvent("mouseout", ref, wrapHandler(onMouseOut), options);
        var enter = useEvent("mouseenter", ref, wrapHandler(onMouseEnter), options);
        var leave = useEvent("mouseleave", ref, wrapHandler(onMouseLeave), options);
        return mergeUseEventResults(down, move, up, over, out, enter, leave);
    };
    var useTouchEvents = function (_a, ref, options) {
        var onTouchStart = _a.onTouchStart, onTouchMove = _a.onTouchMove, onTouchEnd = _a.onTouchEnd, onTouchCancel = _a.onTouchCancel;
        var down = useEvent("touchstart", ref, wrapHandler(onTouchStart), options);
        var move = useEvent("touchmove", ref, wrapHandler(onTouchMove), options);
        var up = useEvent("touchend", ref, wrapHandler(onTouchEnd), options);
        var cancel = useEvent("touchcancel", ref, wrapHandler(onTouchCancel), options);
        return mergeUseEventResults(down, move, up, cancel);
    };
    var useNativePointerEvents = function (_a, ref, options) {
        var onPointerDown = _a.onPointerDown, onPointerMove = _a.onPointerMove, onPointerUp = _a.onPointerUp, onPointerCancel = _a.onPointerCancel, onPointerOver = _a.onPointerOver, onPointerOut = _a.onPointerOut, onPointerEnter = _a.onPointerEnter, onPointerLeave = _a.onPointerLeave;
        var down = useEvent("pointerdown", ref, wrapHandler(onPointerDown), options);
        var move = useEvent("pointermove", ref, wrapHandler(onPointerMove), options);
        var up = useEvent("pointerup", ref, wrapHandler(onPointerUp), options);
        var cancel = useEvent("pointercancel", ref, wrapHandler(onPointerCancel), options);
        var over = useEvent("pointerover", ref, wrapHandler(onPointerOver), options);
        var out = useEvent("pointerout", ref, wrapHandler(onPointerOut), options);
        var enter = useEvent("pointerenter", ref, wrapHandler(onPointerEnter), options);
        var leave = useEvent("pointerleave", ref, wrapHandler(onPointerLeave), options);
        return mergeUseEventResults(down, move, up, cancel, over, out, enter, leave);
    };
    var supportsPointerEvents = function () {
        return window.onpointerdown === null &&
            window.onpointermove === null &&
            window.onpointerup === null;
    };
    var supportsTouchEvents = function () {
        return window.ontouchstart === null &&
            window.ontouchmove === null &&
            window.ontouchend === null;
    };
    var supportsMouseEvents = function () {
        return window.onmousedown === null &&
            window.onmousemove === null &&
            window.onmouseup === null;
    };
    var usePointerEvents = function (eventHandlers, ref, options) {
        var onPointerDown = eventHandlers.onPointerDown, onPointerMove = eventHandlers.onPointerMove, onPointerUp = eventHandlers.onPointerUp, onPointerCancel = eventHandlers.onPointerCancel, onPointerOver = eventHandlers.onPointerOver, onPointerOut = eventHandlers.onPointerOut, onPointerEnter = eventHandlers.onPointerEnter, onPointerLeave = eventHandlers.onPointerLeave;
        var mouseEvents = {}, touchEvents = {}, pointerEvents = {};
        if (supportsPointerEvents()) {
            pointerEvents = eventHandlers;
        }
        else if (supportsTouchEvents()) {
            touchEvents = {
                onTouchStart: onPointerDown,
                onTouchMove: onPointerMove,
                onTouchEnd: onPointerUp,
                onTouchCancel: onPointerCancel,
            };
        }
        else if (supportsMouseEvents()) {
            mouseEvents = {
                onMouseDown: onPointerDown,
                onMouseMove: onPointerMove,
                onMouseUp: onPointerUp,
                onMouseOver: onPointerOver,
                onMouseOut: onPointerOut,
                onMouseEnter: onPointerEnter,
                onMouseLeave: onPointerLeave,
            };
        }
        var pointer = useNativePointerEvents(pointerEvents, ref, options);
        var touch = useTouchEvents(touchEvents, ref, options);
        var mouse = useMouseEvents(mouseEvents, ref, options);
        return mergeUseEventResults(pointer, touch, mouse);
    };
    var useConditionalPointerEvents = function (eventHandlers, ref, options) {
        var pointerEventsRef;
        var pointerEventsHandlers;
        var emptyRef = React.useRef(null);
        if (ref) {
            pointerEventsRef = ref;
            pointerEventsHandlers = eventHandlers;
        }
        else {
            pointerEventsRef = emptyRef;
            pointerEventsHandlers = {};
        }
        usePointerEvents(pointerEventsHandlers, pointerEventsRef, options);
        if (ref) {
            return undefined;
        }
        else {
            return eventHandlers;
        }
    };

    var Point;
    (function (Point) {
        Point.subtract = function (a, b) {
            return { x: a.x - b.x, y: a.y - b.y };
        };
    })(Point || (Point = {}));

    function startDevicePoint(session) {
        return session.pointHistory[0];
    }
    function lastDevicePoint(session) {
        return session.pointHistory[session.pointHistory.length - 1];
    }
    function getVelocity$1(session, timeDelta) {
        var pointHistory = session.pointHistory;
        if (pointHistory.length < 2) {
            return { x: 0, y: 0 };
        }
        var i = pointHistory.length - 1;
        var timestampedPoint = null;
        var lastPoint = lastDevicePoint(session);
        while (i >= 0) {
            timestampedPoint = pointHistory[i];
            if (lastPoint.timestamp - timestampedPoint.timestamp >
                timeDelta * 1000) {
                break;
            }
            i--;
        }
        if (!timestampedPoint) {
            return { x: 0, y: 0 };
        }
        var time = (lastPoint.timestamp - timestampedPoint.timestamp) / 1000;
        if (time === 0) {
            return { x: 0, y: 0 };
        }
        var currentVelocity = {
            x: (lastPoint.x - timestampedPoint.x) / time,
            y: (lastPoint.y - timestampedPoint.y) / time,
        };
        if (currentVelocity.x === Infinity) {
            currentVelocity.x = 0;
        }
        if (currentVelocity.y === Infinity) {
            currentVelocity.y = 0;
        }
        return currentVelocity;
    }
    function usePanGesture(_a, ref) {
        var onPan = _a.onPan, onPanStart = _a.onPanStart, onPanEnd = _a.onPanEnd;
        var session = null;
        var pointer = React.useRef(null);
        var lastMoveEvent = React.useRef(null);
        var lastMoveEventInfo = React.useRef(null);
        var updatePoint = React.useMemo(function () { return function () {
            if (!session ||
                pointer.current === null ||
                lastMoveEventInfo.current === null ||
                lastMoveEvent.current === null) {
                console.error("Pointer move without started session");
                return;
            }
            var _a = lastMoveEventInfo.current, point = _a.point, devicePoint = _a.devicePoint;
            var delta = Point.subtract(devicePoint, lastDevicePoint(session));
            var offset = Point.subtract(devicePoint, startDevicePoint(session));
            var timestamp = getFrameData().timestamp;
            session.pointHistory.push(__assign({}, devicePoint, { timestamp: timestamp }));
            pointer.current.x.set(devicePoint.x);
            pointer.current.y.set(devicePoint.y);
            if (Math.abs(delta.x) > 0 || Math.abs(delta.y) > 0) {
                var velocity = getVelocity$1(session, 0.1);
                var info = {
                    point: point,
                    devicePoint: devicePoint,
                    delta: delta,
                    offset: offset,
                    velocity: velocity,
                };
                if (session.startEvent) {
                    if (onPan) {
                        onPan(lastMoveEvent.current, info);
                    }
                }
                else {
                    if (onPanStart) {
                        onPanStart(lastMoveEvent.current, info);
                    }
                    session.startEvent = lastMoveEvent.current;
                }
            }
            delta.x = 0;
            delta.y = 0;
        }; }, [onPan, onPanStart]);
        var onPointerMove = React.useMemo(function () { return function (event, info) {
            lastMoveEvent.current = event;
            lastMoveEventInfo.current = info;
            sync.update(updatePoint);
        }; }, [onPan, onPanStart]);
        var onPointerUp = React.useMemo(function () { return function (event, _a) {
            var point = _a.point, devicePoint = _a.devicePoint;
            if (!session || pointer.current === null) {
                console.error("Pointer end without started session");
                return;
            }
            cancelSync.update(updatePoint);
            var delta = Point.subtract(devicePoint, lastDevicePoint(session));
            var offset = Point.subtract(devicePoint, startDevicePoint(session));
            var velocity = getVelocity$1(session, 0.1);
            stopPointerMove();
            stopPointerUp();
            if (onPanEnd) {
                onPanEnd(event, {
                    point: point,
                    devicePoint: devicePoint,
                    delta: delta,
                    offset: offset,
                    velocity: velocity,
                });
            }
            session = null;
        }; }, [onPanEnd, onPointerMove]);
        var _b = usePointerEvents({ onPointerUp: onPointerUp }, window), startPointerUp = _b[0], stopPointerUp = _b[1];
        var _c = usePointerEvents({ onPointerMove: onPointerMove }, window, { capture: true }), startPointerMove = _c[0], stopPointerMove = _c[1];
        var onPointerDown = React.useMemo(function () {
            return function (event, _a) {
                var devicePoint = _a.devicePoint, point = _a.point;
                pointer.current = {
                    x: motionValue(point.x),
                    y: motionValue(point.y),
                };
                var timestamp = getFrameData().timestamp;
                session = {
                    target: event.target,
                    pointHistory: [__assign({}, devicePoint, { timestamp: timestamp })],
                };
                startPointerMove();
                startPointerUp();
            };
        }, [onPointerUp, onPointerMove]);
        React.useEffect(function () {
            return function () {
                stopPointerMove();
                stopPointerUp();
            };
        }, []);
        var handlers = { onPointerDown: onPointerDown };
        if (!onPan && !onPanStart && !onPanEnd) {
            handlers = {};
        }
        return useConditionalPointerEvents(handlers, ref);
    }

    var order$2 = ["hover", "tap", "drag"];
    var getGesturePriority = function (gesture) {
        return order$2.indexOf(gesture) + 1;
    };

    var usePropsRef = function (props) {
        var propsRef = React.useRef(props);
        for (var key in props) {
            propsRef.current[key] = props[key];
        }
        return propsRef.current;
    };
    function useTapGesture(props, ref) {
        var session = null;
        var onTap = props.onTap, onTapStart = props.onTapStart, onTapCancel = props.onTapCancel, tapActive = props.tapActive, controls = props.controls;
        var propsRef = usePropsRef(props);
        var handlers = React.useMemo(function () {
            if (!onTap && !onTapStart && !onTapCancel && !tapActive) {
                return {
                    onPointerUp: function () { },
                    onPointerDown: function () { },
                };
            }
            var onPointerUp = function (event, _a) {
                var point = _a.point, devicePoint = _a.devicePoint;
                if (!session) {
                    return;
                }
                if (controls && propsRef.tapActive) {
                    controls.clearOverride(getGesturePriority("tap"));
                }
                if (!ref || event.target !== ref.current) {
                    if (propsRef.onTapCancel) {
                        propsRef.onTapCancel({ point: point, devicePoint: devicePoint }, event);
                    }
                    return;
                }
                if (propsRef.onTap) {
                    propsRef.onTap({ point: point, devicePoint: devicePoint }, event);
                }
                session = null;
            };
            var onPointerDown = function (event, _a) {
                var point = _a.point, devicePoint = _a.devicePoint;
                startPointerUp();
                if (!ref || event.target !== ref.current)
                    return;
                session = {
                    target: event.target,
                };
                if (propsRef.onTapStart) {
                    propsRef.onTapStart({ point: point, devicePoint: devicePoint }, event);
                }
                if (controls && propsRef.tapActive) {
                    controls.start(propsRef.tapActive, {
                        priority: getGesturePriority("tap"),
                    });
                }
            };
            return { onPointerUp: onPointerUp, onPointerDown: onPointerDown };
        }, [
            onTap === undefined,
            onTapStart === undefined,
            onTapCancel === undefined,
        ]);
        var _a = usePointerEvents({ onPointerUp: handlers.onPointerUp }, window), startPointerUp = _a[0], stopPointerUp = _a[1];
        React.useEffect(function () { return function () {
            stopPointerUp();
        }; }, [handlers.onPointerUp]);
        return useConditionalPointerEvents({ onPointerDown: handlers.onPointerDown }, ref);
    }

    var hoverPriority = getGesturePriority("hover");
    var useHoverGesture = function (_a, ref) {
        var hoverActive = _a.hoverActive, onHoverStart = _a.onHoverStart, onHoverEnd = _a.onHoverEnd, controls = _a.controls;
        var handlers = React.useMemo(function () {
            var onPointerEnter = function (event) {
                if (onHoverStart)
                    onHoverStart(event);
                if (hoverActive && controls) {
                    controls.start(hoverActive, {
                        priority: hoverPriority,
                    });
                }
            };
            var onPointerLeave = function (event) {
                if (onHoverEnd)
                    onHoverEnd(event);
                if (hoverActive && controls) {
                    controls.clearOverride(hoverPriority);
                }
            };
            return { onPointerEnter: onPointerEnter, onPointerLeave: onPointerLeave };
        }, [hoverActive, onHoverStart, onHoverEnd, controls]);
        return useConditionalPointerEvents(handlers, ref);
    };

    var useGestures = function (props, ref) {
        usePanGesture(props, ref);
        useTapGesture(props, ref);
        useHoverGesture(props, ref);
    };

    function createLock(name) {
        var lock = null;
        return function () {
            var openLock = function () {
                lock = null;
            };
            if (lock === null) {
                lock = name;
                return openLock;
            }
            return false;
        };
    }

    function shouldDrag(direction, drag, currentDirection) {
        return ((drag === true || drag === "lockDirection" || drag === direction) &&
            (currentDirection === null || currentDirection === direction));
    }
    var getConstraints = function (axis, _a) {
        var top = _a.top, right = _a.right, bottom = _a.bottom, left = _a.left;
        if (axis === "x") {
            return { min: left, max: right };
        }
        else {
            return { min: top, max: bottom };
        }
    };
    var applyOverdrag = function (origin, current, dragElastic) {
        var dragFactor = typeof dragElastic === "number" ? dragElastic : 0.5;
        return mix(origin, current, dragFactor);
    };
    function useDraggable(_a, ref, values, controls) {
        var _b = _a.drag, drag = _b === void 0 ? false : _b, _c = _a.dragPropagation, dragPropagation = _c === void 0 ? false : _c, dragConstraints = _a.dragConstraints, _d = _a.dragElastic, dragElastic = _d === void 0 ? true : _d, _e = _a.dragMomentum, dragMomentum = _e === void 0 ? true : _e, onDragStart = _a.onDragStart, onDragEnd = _a.onDragEnd, onDirectionLock = _a.onDirectionLock;
        var point = React.useRef({}).current;
        var origin = React.useRef({ x: 0, y: 0 }).current;
        var motionContext = React.useContext(MotionContext);
        var handlers = React.useMemo(function () {
            if (!drag)
                return {};
            var currentDirection = null;
            var openGlobalLock = null;
            if (shouldDrag("x", drag, currentDirection)) {
                point.x = values.get("x", 0);
            }
            if (shouldDrag("y", drag, currentDirection)) {
                point.y = values.get("y", 0);
            }
            var updatePoint = function (axis, offset) {
                var p = point[axis];
                if (!shouldDrag(axis, drag, currentDirection) || !p)
                    return;
                var current = origin[axis] + offset[axis];
                if (dragConstraints) {
                    var _a = getConstraints(axis, dragConstraints), min = _a.min, max = _a.max;
                    if (min !== undefined && current < min) {
                        current = dragElastic
                            ? applyOverdrag(min, current, dragElastic)
                            : Math.max(min, current);
                    }
                    else if (max !== undefined && current > max) {
                        current = dragElastic
                            ? applyOverdrag(max, current, dragElastic)
                            : Math.min(max, current);
                    }
                }
                p.set(current);
            };
            var onPanStart = function (event) {
                if (point.x) {
                    origin.x = point.x.get();
                    point.x.stop();
                }
                if (point.y) {
                    origin.y = point.y.get();
                    point.y.stop();
                }
                if (!dragPropagation) {
                    openGlobalLock = getGlobalLock(drag);
                    if (!openGlobalLock) {
                        return;
                    }
                }
                currentDirection = null;
                motionContext.dragging = true;
                onDragStart && onDragStart(event);
            };
            var onPan = function (_event, _a) {
                var offset = _a.offset;
                if (!dragPropagation && !openGlobalLock) {
                    return;
                }
                if (drag === "lockDirection") {
                    if (currentDirection === null) {
                        currentDirection = getCurrentDirection(offset);
                        if (currentDirection !== null) {
                            onDirectionLock && onDirectionLock(currentDirection);
                        }
                        return;
                    }
                }
                updatePoint("x", offset);
                updatePoint("y", offset);
            };
            var onPanEnd = function (event, _a) {
                var velocity = _a.velocity;
                if (!dragPropagation && openGlobalLock) {
                    openGlobalLock();
                }
                if (dragMomentum) {
                    var startMomentum = function (axis) {
                        var _a;
                        if (!shouldDrag(axis, drag, currentDirection))
                            return;
                        var transition = dragConstraints
                            ? getConstraints(axis, dragConstraints)
                            : {};
                        controls.start((_a = {},
                            _a[axis] = 0,
                            _a.transition = __assign({ type: "inertia", velocity: velocity[axis], bounceStiffness: 200, bounceDamping: 40, timeConstant: 325, restDelta: 1 }, transition),
                            _a));
                    };
                    startMomentum("x");
                    startMomentum("y");
                }
                motionContext.dragging = false;
                onDragEnd && onDragEnd(event);
            };
            return { onPanStart: onPanStart, onPan: onPan, onPanEnd: onPanEnd };
        }, [drag, motionContext.dragging]);
        usePanGesture(handlers, ref);
    }
    function getCurrentDirection(offset) {
        var lockThreshold = 10;
        var direction = null;
        if (Math.abs(offset.y) > lockThreshold) {
            direction = "y";
        }
        else if (Math.abs(offset.x) > lockThreshold) {
            direction = "x";
        }
        return direction;
    }
    var globalHorizontalLock = createLock("dragHorizontal");
    var globalVerticalLock = createLock("dragVertical");
    function getGlobalLock(drag) {
        var lock = false;
        if (drag === "y") {
            lock = globalVerticalLock();
        }
        else if (drag === "x") {
            lock = globalHorizontalLock();
        }
        else {
            var openHorizontal_1 = globalHorizontalLock();
            var openVertical_1 = globalVerticalLock();
            if (openHorizontal_1 && openVertical_1) {
                lock = function () {
                    openHorizontal_1();
                    openVertical_1();
                };
            }
            else {
                if (openHorizontal_1)
                    openHorizontal_1();
                if (openVertical_1)
                    openVertical_1();
            }
        }
        return lock;
    }

    var useAnimateValues = function (target, controls, values, transition, onComplete) {
        var isInitialRender = React.useRef(true);
        var prevValues = React.useRef(target);
        React.useEffect(function () {
            var toAnimate = Object.keys(prevValues.current).reduce(function (acc, key) {
                var hasUpdated = target[key] !== undefined &&
                    prevValues.current[key] !== target[key];
                var animateOnMount = isInitialRender.current &&
                    (!values.has(key) ||
                        (values.has(key) &&
                            values.get(key).get() !==
                                target[key]));
                if (hasUpdated || animateOnMount) {
                    acc[key] = target[key];
                }
                return acc;
            }, {});
            isInitialRender.current = false;
            prevValues.current = __assign({}, prevValues.current, target);
            if (Object.keys(toAnimate).length) {
                controls.start(toAnimate, transition).then(onComplete);
            }
        }, [target]);
    };

    var AnimatePropType;
    (function (AnimatePropType) {
        AnimatePropType["Target"] = "Target";
        AnimatePropType["VariantLabel"] = "VariantLabel";
        AnimatePropType["AnimationSubscription"] = "AnimationSubscription";
    })(AnimatePropType || (AnimatePropType = {}));

    function unwrapExports (x) {
    	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
    }

    function createCommonjsModule(fn, module) {
    	return module = { exports: {} }, fn(module, module.exports), module.exports;
    }

    var memoize_cjs_prod = createCommonjsModule(function (module, exports) {
    function memoize(fn) {
      var cache = {};
      return function(arg) {
        return void 0 === cache[arg] && (cache[arg] = fn(arg)), cache[arg];
      };
    }
    Object.defineProperty(exports, "__esModule", { value: !0 }),
      (exports.default = memoize);
    });

    unwrapExports(memoize_cjs_prod);

    var memoize_cjs_dev = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, '__esModule', { value: true });

    function memoize(fn) {
      var cache = {};
      return function (arg) {
        if (cache[arg] === undefined) cache[arg] = fn(arg);
        return cache[arg];
      };
    }

    exports.default = memoize;
    });

    unwrapExports(memoize_cjs_dev);

    var memoize_cjs = createCommonjsModule(function (module) {

    {
      module.exports = memoize_cjs_dev;
    }
    });

    var reactPropsRegex = /^((children|dangerouslySetInnerHTML|key|ref|autoFocus|defaultValue|defaultChecked|innerHTML|suppressContentEditableWarning|suppressHydrationWarning|valueLink|accept|acceptCharset|accessKey|action|allow|allowUserMedia|allowPaymentRequest|allowFullScreen|allowTransparency|alt|async|autoComplete|autoPlay|capture|cellPadding|cellSpacing|challenge|charSet|checked|cite|classID|className|cols|colSpan|content|contentEditable|contextMenu|controls|controlsList|coords|crossOrigin|data|dateTime|default|defer|dir|disabled|download|draggable|encType|form|formAction|formEncType|formMethod|formNoValidate|formTarget|frameBorder|headers|height|hidden|high|href|hrefLang|htmlFor|httpEquiv|id|inputMode|integrity|is|keyParams|keyType|kind|label|lang|list|loop|low|marginHeight|marginWidth|max|maxLength|media|mediaGroup|method|min|minLength|multiple|muted|name|nonce|noValidate|open|optimum|pattern|placeholder|playsInline|poster|preload|profile|radioGroup|readOnly|referrerPolicy|rel|required|reversed|role|rows|rowSpan|sandbox|scope|scoped|scrolling|seamless|selected|shape|size|sizes|slot|span|spellCheck|src|srcDoc|srcLang|srcSet|start|step|style|summary|tabIndex|target|title|type|useMap|value|width|wmode|wrap|about|datatype|inlist|prefix|property|resource|typeof|vocab|autoCapitalize|autoCorrect|autoSave|color|itemProp|itemScope|itemType|itemID|itemRef|results|security|unselectable|accentHeight|accumulate|additive|alignmentBaseline|allowReorder|alphabetic|amplitude|arabicForm|ascent|attributeName|attributeType|autoReverse|azimuth|baseFrequency|baselineShift|baseProfile|bbox|begin|bias|by|calcMode|capHeight|clip|clipPathUnits|clipPath|clipRule|colorInterpolation|colorInterpolationFilters|colorProfile|colorRendering|contentScriptType|contentStyleType|cursor|cx|cy|d|decelerate|descent|diffuseConstant|direction|display|divisor|dominantBaseline|dur|dx|dy|edgeMode|elevation|enableBackground|end|exponent|externalResourcesRequired|fill|fillOpacity|fillRule|filter|filterRes|filterUnits|floodColor|floodOpacity|focusable|fontFamily|fontSize|fontSizeAdjust|fontStretch|fontStyle|fontVariant|fontWeight|format|from|fr|fx|fy|g1|g2|glyphName|glyphOrientationHorizontal|glyphOrientationVertical|glyphRef|gradientTransform|gradientUnits|hanging|horizAdvX|horizOriginX|ideographic|imageRendering|in|in2|intercept|k|k1|k2|k3|k4|kernelMatrix|kernelUnitLength|kerning|keyPoints|keySplines|keyTimes|lengthAdjust|letterSpacing|lightingColor|limitingConeAngle|local|markerEnd|markerMid|markerStart|markerHeight|markerUnits|markerWidth|mask|maskContentUnits|maskUnits|mathematical|mode|numOctaves|offset|opacity|operator|order|orient|orientation|origin|overflow|overlinePosition|overlineThickness|panose1|paintOrder|pathLength|patternContentUnits|patternTransform|patternUnits|pointerEvents|points|pointsAtX|pointsAtY|pointsAtZ|preserveAlpha|preserveAspectRatio|primitiveUnits|r|radius|refX|refY|renderingIntent|repeatCount|repeatDur|requiredExtensions|requiredFeatures|restart|result|rotate|rx|ry|scale|seed|shapeRendering|slope|spacing|specularConstant|specularExponent|speed|spreadMethod|startOffset|stdDeviation|stemh|stemv|stitchTiles|stopColor|stopOpacity|strikethroughPosition|strikethroughThickness|string|stroke|strokeDasharray|strokeDashoffset|strokeLinecap|strokeLinejoin|strokeMiterlimit|strokeOpacity|strokeWidth|surfaceScale|systemLanguage|tableValues|targetX|targetY|textAnchor|textDecoration|textRendering|textLength|to|transform|u1|u2|underlinePosition|underlineThickness|unicode|unicodeBidi|unicodeRange|unitsPerEm|vAlphabetic|vHanging|vIdeographic|vMathematical|values|vectorEffect|version|vertAdvY|vertOriginX|vertOriginY|viewBox|viewTarget|visibility|widths|wordSpacing|writingMode|x|xHeight|x1|x2|xChannelSelector|xlinkActuate|xlinkArcrole|xlinkHref|xlinkRole|xlinkShow|xlinkTitle|xlinkType|xmlBase|xmlns|xmlnsXlink|xmlLang|xmlSpace|y|y1|y2|yChannelSelector|z|zoomAndPan|for|class|autofocus)|(([Dd][Aa][Tt][Aa]|[Aa][Rr][Ii][Aa]|x)-.*))$/; // https://esbench.com/bench/5bfee68a4cd7e6009ef61d23

    var index$3 = memoize_cjs(function (prop) {
      return reactPropsRegex.test(prop) || prop.charCodeAt(0) === 111
      /* o */
      && prop.charCodeAt(1) === 110
      /* n */
      && prop.charCodeAt(2) < 91;
    }
    /* Z+1 */
    );

    var _a$1, _b;
    var makeHookComponent = function (hook) { return function (props) {
        hook(props);
        return null;
    }; };
    var AnimatePropComponents = (_a$1 = {},
        _a$1[AnimatePropType.Target] = makeHookComponent(function (_a) {
            var animate = _a.animate, controls = _a.controls, values = _a.values, transition = _a.transition, onAnimationComplete = _a.onAnimationComplete;
            return useAnimateValues(animate, controls, values, transition, onAnimationComplete);
        }),
        _a$1[AnimatePropType.VariantLabel] = makeHookComponent(function (_a) {
            var animate = _a.animate, _b = _a.inherit, inherit = _b === void 0 ? true : _b, controls = _a.controls, onAnimationComplete = _a.onAnimationComplete, initial = _a.initial;
            return useVariants(animate, inherit, controls, initial, onAnimationComplete);
        }),
        _a$1[AnimatePropType.AnimationSubscription] = makeHookComponent(function (_a) {
            var animate = _a.animate, controls = _a.controls;
            return useAnimationSubscription(animate, controls);
        }),
        _a$1);
    var isVariantLabel = function (prop) {
        return Array.isArray(prop) || typeof prop === "string";
    };
    var isAnimationSubscription = function (_a) {
        var animate = _a.animate;
        return animate instanceof AnimationManager;
    };
    var animatePropTypeTests = (_b = {},
        _b[AnimatePropType.Target] = function (props) {
            return props.animate !== undefined &&
                !isVariantLabel(props.animate) &&
                !isAnimationSubscription(props);
        },
        _b[AnimatePropType.VariantLabel] = function (_a) {
            var variants = _a.variants;
            return variants !== undefined;
        },
        _b[AnimatePropType.AnimationSubscription] = isAnimationSubscription,
        _b);
    var getAnimatePropType = function (props) {
        for (var key in AnimatePropType) {
            if (animatePropTypeTests[key](props))
                return key;
        }
        return undefined;
    };
    var getAnimateComponent = function (animatePropType) {
        return animatePropType ? AnimatePropComponents[animatePropType] : undefined;
    };
    var gestureProps = [
        "drag",
        "onPan",
        "onPanStart",
        "onPanEnd",
        "onTap",
        "onTapStart",
        "onTapCancel",
        "tapActive",
        "onPressStart",
        "onPressEnd",
        "hoverActive",
        "onHoverStart",
        "onHoverEnd",
    ];
    var isGesturesEnabled = function (props) {
        return gestureProps.some(function (key) { return props.hasOwnProperty(key); });
    };
    var isDragEnabled = function (props) { return !!props.drag; };
    var Gestures = makeHookComponent(function (_a) {
        var innerRef = _a.innerRef, props = __rest(_a, ["innerRef"]);
        return useGestures(props, innerRef);
    });
    var Draggable = makeHookComponent(function (_a) {
        var innerRef = _a.innerRef, values = _a.values, controls = _a.controls, props = __rest(_a, ["innerRef", "values", "controls"]);
        return useDraggable(props, innerRef, values, controls);
    });
    var eventHandlers = new Set([
        "onTap",
        "onAnimationComplete",
        "onUpdate",
        "onHoverStart",
        "onHoverEnd",
    ]);
    var validProps = function (props) {
        var valid = {};
        for (var key in props) {
            if (index$3(key) && !eventHandlers.has(key)) {
                valid[key] = props[key];
            }
        }
        return valid;
    };
    var RenderComponent = function (_a) {
        var base = _a.base, props = _a.props, innerRef = _a.innerRef, style = _a.style, values = _a.values;
        var isDOM = typeof base === "string";
        var isSVG = isDOM && svgElements.indexOf(base) !== -1;
        var forwardProps = isDOM ? validProps(props) : props;
        return React.createElement(base, __assign({}, forwardProps, { ref: innerRef, style: isSVG ? style : buildStyleAttr(values, style) }));
    };
    var checkShouldInheritVariant = function (_a) {
        var animate = _a.animate, _b = _a.inherit, inherit = _b === void 0 ? true : _b, variants = _a.variants, hoverActive = _a.hoverActive, tapActive = _a.tapActive;
        var isVariantChild = inherit && variants && !animate && !hoverActive && !tapActive;
        var isAnimationHookChild = inherit && animate instanceof AnimationManager;
        if (isVariantChild || isAnimationHookChild) {
            return true;
        }
        else {
            return false;
        }
    };

    var createMotionComponent = function (Component) {
        var MotionComponent = function (props, externalRef) {
            var ref = useExternalRef(externalRef);
            var values = useMotionValues(ref, props);
            var style = addMotionStyles(values, props.style);
            var animatePropType = getAnimatePropType(props);
            var shouldInheritVariant = checkShouldInheritVariant(props);
            var controls = useAnimationControls(values, props, ref, shouldInheritVariant);
            var context = useMotionContext(controls, props.initial);
            var Animate = getAnimateComponent(animatePropType);
            var handleAnimate = Animate && (React.createElement(Animate, __assign({}, props, { inherit: shouldInheritVariant, innerRef: ref, values: values, controls: controls })));
            var handleGestures = isGesturesEnabled(props) && (React.createElement(Gestures, __assign({}, props, { values: values, controls: controls, innerRef: ref })));
            var handleDrag = isDragEnabled(props) && (React.createElement(Draggable, __assign({}, props, { innerRef: ref, controls: controls, values: values })));
            var handleComponent = (React.createElement(RenderComponent, { base: Component, props: props, innerRef: ref, style: style, values: values }));
            return (React.createElement(MotionContext.Provider, { value: context },
                handleAnimate,
                handleGestures,
                handleDrag,
                handleComponent));
        };
        return React.forwardRef(MotionComponent);
    };

    var motion = elements.reduce(function (acc, element) {
        acc[element] = createMotionComponent(element);
        return acc;
    }, {
        custom: createMotionComponent,
    });

    var useMotionValue = function (init) { return React.useMemo(function () { return motionValue(init); }, []); };

    var useCustomValue = function (parent, getTransformer, comparitor) {
        var value = React.useRef(null);
        return React.useMemo(function () {
            if (value.current)
                value.current.destroy();
            value.current = parent.addChild({ transformer: getTransformer() });
            return value.current;
        }, comparitor);
    };

    var isTransformer = function (v) {
        return typeof v === "function";
    };
    var noop = function () { return function (v) { return v; }; };
    function useTransformedValue(value, transform, to, opts) {
        var comparitor = [value];
        var transformer = noop;
        if (isTransformer(transform)) {
            transformer = function () { return transform; };
        }
        else if (Array.isArray(to)) {
            var from_1 = transform;
            transformer = function () { return interpolate(from_1, to, opts); };
            comparitor = [value, from_1.join(","), to.join(",")];
        }
        return useCustomValue(value, transformer, comparitor);
    }

    var scrollX = motionValue(0);
    var scrollY = motionValue(0);
    var scrollXProgress = motionValue(0);
    var scrollYProgress = motionValue(0);
    var hasEventListener = false;
    var addScrollListener = function () {
        hasEventListener = true;
        if (typeof window === "undefined")
            return;
        var updateScrollValues = function () {
            var xOffset = window.pageXOffset;
            var yOffset = window.pageYOffset;
            scrollX.set(xOffset);
            scrollY.set(yOffset);
            var maxXOffset = document.body.clientWidth - window.innerWidth;
            scrollXProgress.set(xOffset === 0 ? 0 : xOffset / maxXOffset);
            var maxYOffset = document.body.clientHeight - window.innerHeight;
            scrollYProgress.set(yOffset === 0 ? 0 : yOffset / maxYOffset);
        };
        updateScrollValues();
        window.addEventListener("resize", updateScrollValues);
        window.addEventListener("scroll", updateScrollValues, { passive: true });
    };
    var viewportMotionValues = {
        scrollX: scrollX,
        scrollY: scrollY,
        scrollXProgress: scrollXProgress,
        scrollYProgress: scrollYProgress,
    };
    var useViewportScrollValues = function () {
        if (!hasEventListener) {
            addScrollListener();
        }
        return viewportMotionValues;
    };

    var useAnimation = function (variants, defaultTransition) {
        var animationManager = React.useMemo(function () { return new AnimationManager(); }, []);
        if (variants) {
            animationManager.setVariants(variants);
        }
        if (defaultTransition) {
            animationManager.setDefaultTransition(defaultTransition);
        }
        React.useEffect(function () {
            animationManager.mount();
            return function () { return animationManager.unmount(); };
        }, []);
        return animationManager;
    };

    var useCycle = function (items, initialIndex) {
        if (initialIndex === void 0) { initialIndex = 0; }
        var numItems = items.length;
        var _a = React.useState(initialIndex), index = _a[0], setIndex = _a[1];
        return [
            items[index],
            function (next) {
                var newIndex = typeof next !== "number" ? wrap$1(0, numItems, index + 1) : next;
                setIndex(newIndex);
            },
        ];
    };

    exports.motion = motion;
    exports.useMotionValue = useMotionValue;
    exports.useTransformedValue = useTransformedValue;
    exports.useViewportScrollValues = useViewportScrollValues;
    exports.useAnimation = useAnimation;
    exports.useTapGesture = useTapGesture;
    exports.usePanGesture = usePanGesture;
    exports.useGestures = useGestures;
    exports.useCycle = useCycle;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
