import { RefObject } from "react";
import { Point, EventHandler } from "../events";
export interface PanInfo {
    point: Point;
    devicePoint: Point;
    delta: Point;
    offset: Point;
    velocity: Point;
}
export declare type PanHandler = (event: Event, info: PanInfo) => void;
export interface PanHandlers {
    onPan?: PanHandler;
    onPanStart?: PanHandler;
    onPanEnd?: PanHandler;
}
export declare function usePanGesture(handlers: PanHandlers, ref: RefObject<Element>): undefined;
export declare function usePanGesture(handlers: PanHandlers): {
    onPointerDown: EventHandler;
};
