import { RefObject } from "react";
import { Point, EventHandler } from "../events";
import { TargetAndTransition } from "../types";
import { ControlsProp } from "./types";
interface TapInfo {
    point: Point;
    devicePoint: Point;
}
declare type TapHandler = (session: TapInfo, event: Event) => void;
export interface TapHandlers {
    onTap?: TapHandler;
    onTapStart?: TapHandler;
    onTapCancel?: TapHandler;
    tapActive?: string | TargetAndTransition;
}
export declare function useTapGesture(handlers: TapHandlers & ControlsProp): {
    onPointerDown: EventHandler;
};
export declare function useTapGesture(handlers: TapHandlers & ControlsProp, ref: RefObject<Element>): undefined;
export {};
