import { ComponentType, ReactHTML, SVGAttributes, DetailedHTMLFactory } from "react";
import { HTMLElements, SVGElements } from "./utils/supported-elements";
export { MotionContext } from "./utils/MotionContext";
export { MotionValuesMap } from "./utils/use-motion-values";
export { AnimationControls } from "./utils/use-animation-controls";
import { MotionProps } from "./types";
import { createMotionComponent } from "./component";
declare type Omit<T, K extends keyof T> = Pick<T, Exclude<keyof T, K>>;
declare type UnwrapFactory<F> = F extends DetailedHTMLFactory<infer P, any> ? P : never;
export declare type HTMLMotionComponents = {
    [K in HTMLElements]: ComponentType<Omit<UnwrapFactory<ReactHTML[K]>, "style"> & MotionProps>;
};
export declare type SVGMotionComponents = {
    [K in SVGElements]: ComponentType<Omit<SVGAttributes<SVGElement>, "style"> & MotionProps>;
};
export declare type CustomMotionComponent = {
    custom: typeof createMotionComponent;
};
export declare type MotionComponents = CustomMotionComponent & HTMLMotionComponents & SVGMotionComponents;
export declare const motion: MotionComponents;
