import { RefObject } from "react";
import { MotionValue } from "../../value";
import { OnUpdate, MotionProps } from "../types";
export declare class MotionValuesMap {
    private hasMounted;
    private styler;
    private onUpdate?;
    private shouldRender;
    private values;
    private unsubscribers;
    has(key: string): boolean;
    set(key: string, value: MotionValue): void;
    get<Value>(key: string): MotionValue<Value> | undefined;
    get<Value>(key: string, defaultValue: Value): MotionValue<Value>;
    forEach(callback: (value: MotionValue, key: string) => void): void;
    bindValueToStyler(key: string, value: MotionValue): void;
    setOnUpdate(onUpdate?: OnUpdate): void;
    setShouldRender(render: boolean): void;
    mount(element: Element): void;
    unmount(): void;
}
export declare const useMotionValues: (ref: RefObject<Element>, { onUpdate, render }: MotionProps) => MotionValuesMap;
